// ==UserScript==
// @name           Autofuzz
// @namespace      http://www.squarefree.com/fuzzery
// @description    For use with autofuzz.exe - Paul Nickerson's port of af_timed_run.py
// @include        *#squarefree-af*
// ==/UserScript==



function load(sURL)
{
  var script = document.createElementNS("http://www.w3.org/1999/xhtml", "script");
  script.src = sURL;
  var par = (document.body || document.documentElement);
  
  par.appendChild(script);
  
  function yank() { par.removeChild(script); }
  
  setTimeout(yank, 300); // so this *temporary* script element doesn't confuse the fuzzer
}

function exec(sText)
{
  load("data:text/javascript," + encodeURIComponent(sText));
  // Attempt to work around bug 366417 by using this instead:
  // document.location = "javascript:" + encodeURIComponent(sText) + "; void 0;";
  // Unfortunately, it seems like the script-src's are broken too, so this workaround is pointless!
}

function mmRnd(n) { return Math.floor(Math.random() * n); }
function mmRndElt(a) { return a[mmRnd(a.length)]; }

var prefix = "http://localhost/fuzzers/";

load(prefix + "fuzz.js");

if (location.hash == "#squarefree-af")
{
	//this portion of code shouldnt be used with the windows port of autofuzz
  var knownFuzzers = ["fuzzer-bindings.js",  "fuzzer-designMode.js", "fuzzer-html-attributes.js", "fuzzer-javascript-src.js", "fuzzer-mathml-attributes.js", "fuzzer-mutations.js", "fuzzer-random-js.js", "fuzzer-random-styles.js", "fuzzer-stir-dom.js", "fuzzer-stir-table.js", "fuzzer-svg-attributes.js", "fuzzer-xul-attributes.js", "fuzzer-stir-attributes.js"];
	//
	//var maxSteps
  // not featured:
  //   "fuzzer-deepen.js",            // used to find hangs, mostly
  //   "fuzzer-new-script-nodes.js"   // why not?
  
//  var knownFuzzers = ["fuzzer-random-js.js"];
  
  var chosenFuzzer = mmRndElt(knownFuzzers);
  
  exec("chosenFuzzer = " + uneval(chosenFuzzer)); // ??

  load(prefix + chosenFuzzer);

  load(prefix + "fuzz-finish-auto.js");

  load(prefix + "fuzz-start-auto.js");
} else {
	//some fuzzers want to show some information. we dont need that!
	window.alert = function(){void 0;};
	
  // Specified fuzzer?
  r = location.hash.slice("#squarefree-af".length + 1);
   
  r = r.split("!");
  
  load(prefix + r[0]);
  
  setTimeout(function() { 
    exec("fuzzSettings = [" + r[1] + ",suggestedMaxSteps,1];");
    exec("setTimeout(fuzzOnload, 400);");
  }, 600);
}

