// === Paste output from first run here, replacing the following two lines: ===

var fuzzSettings = null;
var fuzzCommands = null;
//var reportRuntimeErrors = true;

// === End pasteover ===


var fuzzerName = "Canvas API fuzzer 3.1";
var recordStrategy = "Record as it goes";
dumpEachCommand=true;
var suggestedMaxSteps = 4000;


var allNodes;
var myRoot;
var anonymousCount; // number of anonymous children (not descendents, just children)
var canvas;


var HTML_NS = "http://www.w3.org/1999/xhtml";

function aC(q1, q2) { q1.appendChild(q2); }
function iB(q1, q2) { q1.parentNode.insertBefore(q2, q1); }
function rM(q1) { q1.parentNode.removeChild(q1); } // unused, but can be useful while narrowing testcases
// other things to try: clone instead of move, ...

function makeCommand()
{
	var i;
	var arglist;
	function totallyRandomThing()
	{
		return randomThing([numbers, texts, CreateStyle, CreateColor, URIs, [0,"0",.5,1,-.5,-1,-100000000000, rnd(1000), rndr()]]);
	}
	
  var n1index = rnd(allNodes.length);
  var n1 = "allNodes[" + n1index + "]";
  
  //var n2 = allNodes[n2index];
  
  var command = "canvas.getContext('2d').";

  switch (rnd(9)) {
  case 0:
  case 1:
  case 2:
    // Change a canvas context attribute
    var attr = rndElt(allattribs);
      
    var value = randomThing(rnd(5)==1 ? totallyRandomThing : attributes[attr]);
    
    command += attr + " = " + uneval(value) + ";";
    
    return command;
  case 3:
  case 4:
  case 5:
  	// Call a canvas context method
  	var methd = rndElt(allmethods);
  	arglist = methods[methd]
  	
  	command += methd + "(";
  	var argvalue;
  	
  	for (i=0;i<arglist.length;i++){
  		argvalue = randomThing(rnd(5)==1 ? totallyRandomThing : arglist[i])
  		command += uneval(argvalue);
  		if (i+1<arglist.length)
  			command += ",";
  	}
  	command += ");"
  	return command;
  case 6:
  case 7:
  	//move stuff around (appendChild)
  	if (rnd(3) != 0 )
  		command = "aC(" + n1 + ",canvas)";
  	else
  		command = "aC(canvas," + n1 +")";
  	return command;
  case 8:
    //move stuff around (insertBefore)
  	if (rnd(3) != 0 )
  		command = "iB(" + n1 + ",canvas)";
  	else
  		command = "iB(canvas," + n1 +")";
  	return command;
  }

  return command;
  
}



function resetNodeList() {
  allNodes=[];
  anonymousCount = 0;
  var myRoot = doc.body || doc.documentElement; 
  addDOMNodes(myRoot);
}


function initFuzzerSpecific() { 
	canvas = document.getElementById("canvas");
	if (!canvas)
	{
		//create a canvas
		canvas = document.createElement("<canvas id=\"canvas\" width=\"100\" height=\"100\"></canvas>");
		document.body.appendChild(canvas);
	}
  resetNodeList();
  startFuzzing();
}

function rndr(){
	//returns a random real number up to the 4th decimal
	return rnd(1000)/1000;
}


function CreateColor(){
	if (rnd(2))
		return "\"" + randomThing(colors) + "\""		//return an html-style color
		
	//return a css-style color
	return randomThing([
		"\"rgb(" + randomThing([rnd(256),numbers]) + "," + randomThing([rnd(256),numbers]) + "," + randomThing([rnd(256),numbers]) + ")\"",
		"\"rgba(" + randomThing([rnd(256),numbers]) + "," + randomThing([rnd(256),numbers]) + "," + randomThing([rnd(256),numbers]) + "," + randomThing([0,"0",.5,1,-.5,-1,-100000000000, numbers, rndr()]) + ")\""]);
}

function CreateStyle(){
	//creates a random style that can be used with fillStyle and strokeStyle
	var grad = null;
	var i = 0;
	var noerr = false;
	var funcreturn;
	
	function rndNumForHere() {
		//this gets called often, so we might as well have a separate function to clean things up a bit
		return randomThing([[0,"0",.5,1,-.5,-1,-100000000000], numbers, rnd(1000), rndr()]);
	}
	
	while (1){	//keep going until we return something. shouldnt have to repeat but just in case...
		try {
			switch (rnd(3)) {
			case 0:
			case 1:
				return CreateColor();
			case 2:
				//return a pattern
				switch (rnd(4)) {
				case 0:
					funcreturn = "function(ctx){/*create a linear gradient*/" +
						"var grad = ctx.createLinearGradient(" +
						rndNumForHere() + "," +
						rndNumForHere() + "," +
						rndNumForHere() + "," +
						rndNumForHere() + ");" +
						"/*add some colors to the gradient*/"
						for (i=0;i<rnd(10);i++)
						{
							funcreturn += "	try{" +
							"		grad.addColorStop(" +
										randomThing([0, '0', .5, 1, -.5, -1, numbers, rndr()]) + "," +
										CreateColor() + ");" +
							"	}catch(Exx2){}"
						}
						funcreturn += "}(mycontext)";
					return funcreturn;
					
				case 1:
						funcreturn = "function(ctx){/*create a radial gradient*/" +
						"var grad = ctx.createLinearGradient(" +
						rndNumForHere() + "," +
						rndNumForHere() + "," +
						rndNumForHere() + "," +
						rndNumForHere() + "," +
						rndNumForHere() + "," +
						rndNumForHere() + ");" +
						"/*add some colors to the gradient*/"
						for (i=0;i<rnd(10);i++)
						{
							funcreturn += "	try{" +
							"		grad.addColorStop(" +
										randomThing([0, '0', .5, 1, -.5, -1, numbers, rndr()]) + "," +
										CreateColor() + ");" +
							"	}catch(Exx2){}"
						}
						funcreturn += "}(mycontext)";
					return funcreturn;
					
				case 2:
					//create an image-based pattern
					
					/*	this function has three variants:
					context.drawImage(image, x, y)
					context.drawImage(image, x, y, width, height)
					context.drawImage(image, sx, sy, swidth, sheight, dx, dy, dwidth, dheight)
					*/
					switch (rnd(3)){
					case 0:
						return "function(ctx){ctx.drawImage('" +
							randomThing([URIs,URIs,texts]) + "'," +
							rndNumForHere() + "," +
							rndNumForHere() + ")(mycontext)"
					case 1:
						return "function(ctx){ctx.drawImage('" +
							randomThing([URIs,URIs,texts]) + "'," +
							rndNumForHere() + "," +
							rndNumForHere() + "," +
							rndNumForHere() + "," +
							rndNumForHere() + ")(mycontext)"
					case 2:
						return "function(ctx){ctx.drawImage('" +
							randomThing([URIs,URIs,texts]) + "'," +
							rndNumForHere() + "," +
							rndNumForHere() + "," +
							rndNumForHere() + "," +
							rndNumForHere() + "," +
							rndNumForHere() + "," +
							rndNumForHere() + "," +
							rndNumForHere() + "," +
							rndNumForHere() + ")(mycontext)"
					}
				case 3:
					//return a repeating pattern
					return "function(ctx){ctx.createPattern('" +
						randomThing([URIs,URIs,texts]) + "','" +
						randomThing(["repeat","repeat-x","repeat-y","no-repeat"]) + "');}(mycontext)";
				}
			}
		}catch(Exx){}
	}
}

function randomThing(obj)
{
  if (obj == null)
    return null;
    
  if (typeof obj == "function")
    return obj();
    
  if (typeof obj == "string")
    return obj; // not to be treated as an array :)

  if (obj.length) { // non-empty array
    var x = rndElt(obj);
    //dumpln(x);
    return randomThing(x)
  }

  if (obj.length === 0)
    return null;

  // Otherwise, it should be a number, etc.
  return obj;
}


var names =    [  "a",  "b",  "c",  "d",  "e",  "f",  "g",  "1" ];
var namerefs = [ "#a", "#b", "#c", "#d", "#e", "#f", "#g", "#1" ];
var charsets = [ "UTF-8", "ISO-8859-1" ];
//note to self: if errors appear, try commenting out the javascript entries below
var URIs = ["http://www.squarefree.com/", "http://www.squarefree.com/feed", "#a", "#b", "data:text/html,", "javascript:alert(Components.classes)", "javascript:5555", "javascript:'QQQQ' + String.fromCharCode(0) + 'UUUU'",  "http://www.mozilla.org/status/tree.gif", "http://" + longThing(), longThing];
var numbers = [-2, -1, 0, "-0", "+0", 1, "+1", 0xffffffff, 0xfffffffe, 0x80000000, 0x7fffffff, 0x7ffffffe, 0x3fffffff, 0x100000, 0x10000, 0x1000, 0x100];
function numbersWithUnits() { return rndElt(numbers) + rndElt(["px", "em", "pt", "%", ""]) }
var relations = ["alternate"];
var mimeTypes = ["text/html", "text/plain", "text/css", "text/javascript", "application/rss+xml"];
var texts = ["", "foo", "Abbey\nRoad", 'QQQQ' + String.fromCharCode(0) + 'UUUU', longThing, "%n%n%n%n%n%n%n%n%n%n%n%n%n%n%n%n%n%n%n%n%n%n%n%n%n%n%n%n%n%n", "%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s"];
var colors = ["lime", "red", "blue", "#CCC", "#777777", longThing];


function longThing()
{
  // a string of all A's in a buffer overflow has the nice property
  // of a guaranteed crash on some architectures, IIRC
  
  var x = "A"; 
  for (var i = 0; i < 14; ++i)
    x = x + x;
  return x; 
}

var allattribs = ["fillStyle","globalAlpha",
	"globalCompositeOperation","globalCompositeOperation","globalCompositeOperation",	/*we have so many possible values for this attribute that we use it often*/
	"lineCap","lineJoin","lineWidth","miterLimit","shadowBlur","shadowColor","shadowOffsetX","shadowOffsetY","strokeStyle"];

var attributes = {
	"fillStyle": CreateStyle,
	"globalAlpha": [0, "0", .5, 1],
	"globalCompositeOperation": ["copy", "darker", "destination-atop", "destination-in", "destination-out", "destination-over", "lighter", "source-atop", "source-in", "source-out", "source-over", "xor"],
	"lineCap": ["butt", "round", "square"],
	"lineJoin": ["round", "bevel", "miter"],
	"lineWidth": numbers,
	"miterLimit": numbers,
	"shadowBlur": numbers,
	"shadowColor": colors,
	"shadowOffsetX": numbers,
	"shadowOffsetY": numbers,
	"strokeStyle": CreateStyle
};

// attributes is a hash, but sometimes we want to treat it as an array-like thing.  so....
attributeList = [];
for (var prop in attributes)
  attributeList.push(prop);

function totallyRandomAttr() {
  return rndElt(attributeList); 
}

var allmethods = ["restore","rotate","save","scale","translate","arc","arcTo","bezierCurveTo","beginPath","clip","closePath","lineTo","moveTo","quadraticCurveTo","rect","stroke","strokeRect","clearRect","fill","fillRect","createLinearGradient","createPattern","createRadialGradient","drawImage"];

/*
method layout:
"name": [arg values, arg values, ...]
*/

var methods = {
	"restore": [],
	"rotate": [numbers],
	"save": [],
	"scale": [numbers, numbers],
	"translate": [numbers, numbers],
	"arc": [numbers, numbers, numbers, numbers, numbers, [1, 0]],
	"arcTo": [numbers, numbers, numbers, numbers, numbers],
	"bezierCurveTo": [numbers, numbers, numbers, numbers, numbers, numbers],
	"beginPath": [],
	"clip": [],
	"closePath": [],
	"lineTo": [numbers, numbers],
	"moveTo": [numbers, numbers],
	"quadraticCurveTo": [numbers, numbers, numbers, numbers],
	"rect": [numbers, numbers, numbers, numbers],
	"stroke": [],
	"strokeRect": [numbers, numbers, numbers, numbers],
	"clearRect": [numbers, numbers, numbers, numbers],
	"fill": [],
	"fillRect": [numbers, numbers, numbers, numbers],
	"createLinearGradient": [numbers, numbers, numbers, numbers],
  "createPattern": [[URIs, texts], ["repeat", "repeat-x", "repeat-y", "no-repeat"]],
  "createRadialGradient": [numbers, numbers, numbers, numbers, numbers, numbers],
	"drawImage": [[URIs, texts], numbers, numbers, numbers, numbers, numbers, numbers, numbers, numbers]
};