// === Paste output from first run here, replacing the following two lines: ===

var fuzzSettings = null;
var fuzzCommands = null;

// === End pasteover ===


var fuzzerName = "Deepen fuzzer 3.1";
var recordStrategy = "Record as it goes";
var suggestedMaxSteps = 400; // this fuzzer can detect hangs, but it also just tends to be slow.  so, to keep the false positives down, let's do this.

dumpEachCommand = true;


var allNodes;
var fuzzRoot;


// dumpEachCommand = true;


function aC(q1, q2) { q1.appendChild(q2); }
function iB(q1, q2) { q1.parentNode.insertBefore(q2, q1); }
function rM(q1) { q1.parentNode.removeChild(q1); } // unused, but can be useful while narrowing testcases
// other things to try: clone instead of move, ...

/*
 * For example, say the document looks like
 *  <body><table><tr><td><strong>Foo
 *  Then calling deepen(n1, 2, depth) will repeat <table><tr><td>
 */

function deepen(n1, numAncestors, depth)
{
  // Create a list of up to (numAncestors + 1) elements, ending with n1.

  var ancestors = [];
  var i, a;
  for (i = 0, a = n1; a && i <= numAncestors; ++i, a = a.parentNode) {
    ancestors.push(a);
  }
  
  ancestors.reverse(); // so for n1=td, numAncestors=3, this might be [table, tr, td] now
  
  // Build from the outside in, leaving the original n1 (outermost) in place for now.
  
  var outermost = n1.cloneNode(false);
  var outer = outermost;
  var inner = outermost;

  for (i = 0; i < depth; ++i) {
    inner = ancestors[i % ancestors.length].cloneNode(false);
    outer.appendChild(inner);
    outer = inner;
  }
  
  // Now for the part that actually affects the document:
  // 1. Replace n1 in the document with outermost.  (This removes n1 from the document.)
  // 2. Put the original n1 (with its subtree) inside inner.
  
  if (n1.parentNode)
    n1.parentNode.replaceChild(outermost, n1);
    
  inner.appendChild(n1);
  
  return outermost;
}


function makeCommand()
{
  while(1){

  var n1index = rnd(allNodes.length), n2index = rnd(allNodes.length);
  
  var n1 = allNodes[n1index];
  var n2 = allNodes[n2index];
  
  var commandn1 = "allNodes[" + n1index + "]";
  var commandn2 = "allNodes[" + n2index + "]";
  var command;
  

  switch (rnd(6)) {
  case 0:
  case 1:
  case 2:

    // Make a random node deeper.

    if (n1 && n1.nodeType == Node.ELEMENT_NODE) {
    
      var MAX_REFLOW_DEPTH = 200; // from gecko

      var depth = Math.floor(200 / (rnd(6)+1) + (10 - rnd(21)));
      var numAncestors = rnd(4);

      return "allNodes[" + allNodes.length + "] = deepen(" + commandn1 + ", " + numAncestors + ", " + depth + ");";
    }
    else {
      break;
    }
      

  case 3:
  case 4:
  case 5:
    // Move n2 in some way..
    
    if(n2index > 1) { // This fuzzer avoids screwing with the root node.
  
      if (rnd(20) == 1)
        // Don't do this too often -- it tends to make things less interesting.
        return "rM(" + commandn2 + ");";
      
      if (rnd(9) == 3)
        // Don't do this too often either -- it hurts reduction and it doesn't buy us much
        return "iB(" + commandn1 + ", " + commandn2 + ");";
        
      // Do this a lot ;)
      return "aC(" + commandn1 + ", " + commandn2 + ");";
    }
    
    break;
    



  }
  }
  
}






function resetNodeList() {
  allNodes = [];
  fuzzRoot = doc.body || doc.documentElement;
  addDOMNodes(fuzzRoot);
}


function initFuzzerSpecific() { 
  resetNodeList();
  startFuzzing();
}
