// === Paste output from first run here, replacing the following two lines: ===

var fuzzSettings = null;
var fuzzCommands = null;

// === End pasteover ===


var fuzzerName = "HTML Element and Attribute fuzzer 3.1";
var recordStrategy = "Record as it goes";
var suggestedMaxSteps = 20000;

// dumpEachCommand = true;


var allNodes;
var fuzzRoot;

var HTML_NS = "http://www.w3.org/1999/xhtml";

// dumpEachCommand = true;


function aC(q1, q2) { q1.appendChild(q2); }
function iB(q1, q2) { q1.parentNode.insertBefore(q2, q1); }
function rM(q1) { q1.parentNode.removeChild(q1); } // unused, but can be useful while narrowing testcases
// other things to try: clone instead of move, ...

function makeCommand()
{
  var n1index = rnd(allNodes.length), n2index = rnd(allNodes.length);
  
  var n1 = allNodes[n1index];
  var n2 = allNodes[n2index];
  
  var commandn1 = "allNodes[" + n1index + "]";
  var commandn2 = "allNodes[" + n2index + "]";
  var command;
  
  while(1){
  switch (rnd(9)) {
  case 0:
  case 1:
  case 2:
  
    // Change an attribute on n1, based on n1's tagName.
    
    if (!n1.tagName)
      break;
      
    var attrs = rnd(2) ? elements[n1.tagName] : commonAttributes;
    var attr = attrs ? rndElt[attrs] : null;
    if (!attr || rnd(5) == 1) {
      attr = totallyRandomAttr();
      // dumpln("*** " + attr);
    }
      
    var value = randomThing(rnd(5) == 1 ? attributes[totallyRandomAttr()] : attributes[attr]);
    
    if (attr) {
      if (rnd(2))
        // Set it as a property.
        return commandn1 + "['" + attr + "'] = " + simpleSource(value) + ";";
      else 
        // Set it as an attribute.
        return commandn1 + ".setAttribute('" + attr + "', " + simpleSource(value) + ");";
    }
      
    break;
    
  case 3:
    // Remove an attribute on n1, based on n1's current attribute list.
    
    var attrs = n1.attributes;
    if (attrs && attrs.length) {
      var attr = rndElt(attrs).name;
      return commandn1 + ".removeAttribute('" + attr + "');";
    }
    
    break;
    
  case 4:
    // Create a new element!
    // Set some attributes on it?  Nah.
    // Place it randomly, but only rarely place it outside of the document, because that's usually boring.
    
    var tag = rndElt(elementList);
    var newIndex = allNodes.length;
    

    var createness;
    if ((tag == "foo") != (rnd(10) == 1))
      createness = "var ne = document.createElementNS('bar', '" + tag + "'); allNodes[" + newIndex + "] = ne; ";
    else
      createness = "var ne = document.createElementNS(HTML_NS, '" + tag + "'); allNodes[" + newIndex + "] = ne; ";
    
    
    function isInDoc(n) { if (!n) return false; if (n.nodeType == Node.DOCUMENT_NODE) return true; return isInDoc(n.parentNode); }

    if (isInDoc(n1) != (rnd(10) == 1))
      return createness + commandn1 + ".appendChild(ne); ";
    else
      return createness + "fuzzRoot.appendChild(ne); ";

    break;

  case 5:
  case 6:
  case 7:
    // Move n2 in some way..
    
    if(n2index > 1) { // This fuzzer avoids screwing with the root node.
  
      if (rnd(20) == 1)
        // Don't do this too often -- it tends to make things less interesting.
        return "rM(" + commandn2 + ");";
      
      if (rnd(9) == 3)
        // Don't do this too often either -- it hurts reduction and it doesn't buy us much
        return "iB(" + commandn1 + ", " + commandn2 + ");";
        
      // Do this a lot ;)
      return "aC(" + commandn1 + ", " + commandn2 + ");";
    }
    
    break;
    
  case 8:
    // Add some text -- this is partly for visual effect rather than finding more bugs.
  
    if (rnd(4) == 1)
      return "aC(" + commandn1 + ", allNodes[" + allNodes.length + "] = document.createTextNode(''));";
    else if (rnd(3) == 1)
      return "aC(" + commandn1 + ", allNodes[" + allNodes.length + "] = document.createTextNode('" + decodeURIComponent("%28%D7%A2%D6%B4%D7%91%D6%B0%D7%A8%D6%B4%D7%99%D7%AA") + "'));"; // hebrew
    else if (rnd(4) == 1)
      return "aC(" + commandn1 + ", allNodes[" + allNodes.length + "] = document.createTextNode('" + decodeURIComponent("%D8%A7%D9%84%D8%B9%D8%B1%D8%A8%D9%8A") + "'));"; // arabic?
    else
      return "aC(" + commandn1 + ", allNodes[" + allNodes.length + "] = document.createTextNode('<" + n1.tagName + ">'));";

  }
  }
  
}


function resetNodeList() {
  allNodes = [];
  fuzzRoot = doc.body || doc.documentElement;
  addDOMNodes(fuzzRoot);
}


function initFuzzerSpecific() { 
  if (document.body)
    document.body.style.width = "300px"; // encourage wrapping
  resetNodeList();
  startFuzzing();
}



function randomThing(obj)
{
  if (obj == null)
    return null;
    
  if (typeof obj == "function")
    return obj();
    
  if (typeof obj == "string")
    return obj; // not to be treated as an array :)

  if (obj.length) { // non-empty array
    var x = rndElt(obj);
    //dumpln(x);
    return randomThing(x)
  }

  if (obj.length === 0)
    return null;

  // Otherwise, it should be a number, etc.
  return obj;
}



var names =    [  "a",  "b",  "c",  "d",  "e",  "f",  "g",  "1" ];
var namerefs = [ "#a", "#b", "#c", "#d", "#e", "#f", "#g", "#1" ];
var charsets = [ "UTF-8", "ISO-8859-1" ];
var URIs = ["http://www.squarefree.com/", "http://www.squarefree.com/feed", "#a", "#b", "data:text/html,", /* "javascript:alert(Components.classes)", "javascript:5555", "javascript:'QQQQ' + String.fromCharCode(0) + 'UUUU'" -- avoid bug 343940 */,  "http://www.mozilla.org/status/tree.gif"];
var numbers = [-2, -1, 0, "-0", "+0", 1, "+1", 2, 3, 4, 5, 6, 7, 8, 100];
function numbersWithUnits() { return rndElt(numbers) + rndElt(["px", "em", "pt", "%", ""]) }
var relations = ["alternate"];
var mimeTypes = ["text/html", "text/plain", "text/css", "text/javascript", "application/rss+xml"];
var texts = ["", "foo", "bar", "baz", "zap", "Abbey\nRoad", 'QQQQ' + String.fromCharCode(0) + 'UUUU'];
var colors = ["lime", "red", "blue", "#CCC", "#777777"];

function longThing()
{
  // a string of all A's in a buffer overflow has the nice property
  // of a guaranteed crash on some architectures, IIRC
  
  var x = "A"; 
  for (var i = 0; i < 14; ++i)
    x = x + x;
  return x; 
}


var commonAttributes = ["id", "name", "width", "height"];

var attributes = {
"randomcrap": ["", "\0", longThing],
"id": names,
"name": names,
"for": names, // does not use #.  what about <script for> -- is that different?
"usemap": namerefs, // uses #
"href": [namerefs, URIs],
"type": [
  mimeTypes, // <link> elements
  ["text", "password", "file", "radio", "checkbox", "submit", "reset", "image", "button"], // <input> elements
  ["i","1","A","I","a"] // list types in HTML 3.2
  ],
"enctype": mimeTypes,
"accept": mimeTypes,
"accept-charset": charsets,
"charset": charsets,
"action": URIs,
"method": ["GET", "POST"],
"maxlength": numbers,
"tabindex": numbers,
"width": [numbers, numbersWithUnits],
"height": [numbers, numbersWithUnits],
// "dir": ["rtl", "ltr"],
"dir": ["inherit"],
"checked": "checked",
"disabled": "disabled",
"readonly": "readonly",
"size": numbers,
"maxlength": numbers,
"src": URIs,
"alt": texts,
"ismap": "ismap", // ?
"accesskey": names, // hack
"multiple": "multiple", // ?
"selected": "selected",
"label": texts,
"rows": numbers,
"cols": numbers,
"rel": relations,
"rev": relations,

// Image maps
"shape": "rect",
"coords": "5,10,15,20",
"nohref": "nohref", // ?

"longdesc": URIs,

"object": ["declare", "classid", "codebase", "data", "type", "codetype", "archive", "standby", "height", "width", "usermap", "name", "tabindex"],
"param": ["id", "name", "value", "valuetype", "type"],

"pluginspage": URIs,
"cite": URIs,
"datetime": "2006-06-04", // ?




// "meta": "http-equiv", "name", "content", "scheme"


"media": [], // ?
"defer": "defer",
"event": [],



"align": ["left", "center", "right", "justify", ":", // HTML 4 for tables (colon is for "char" in the HTML 4 spec (?))
          "top", "middle", "bottom", "left", "right" ], // HTML 3.2 for images 

"vspace": numbers,
"hspace": numbers,

"bgcolor": colors,
"text": colors,
"link": colors,
"vlink": colors,
"alink": colors,

"color": colors,

"background": URIs,

"noshade": "noshade", // ?


// Tables -- be nice to them for now; stirtable takes care of most of it.
/*
"valign": ["top", "middle", "bottom", "baseline"],
"border": numbers,
"cellspacing": numbers,
"cellpadding": numbers,
"summary": texts,
"span": numbers,
"rowspan": numbers,
"colspan": numbers,
"scope": ["row", "col", "rowgroup", "colgroup"],
"headers": names, // really multiple names
"axis": names, // ?

// Obscure stuff from the TABLES section of http://www.w3.org/TR/REC-html40/sgml/dtd.html
"frame": ["void", "above", "below", "hsides", "lhs", "rhs", "vsides", "box", "border"],
"rules": ["none", "groups", "rows", "cols", "all"]
*/

// marquee
"behavior": ["scroll", "slide", "alternate"],
"direction": ["left", "right", "down", "up"],
"loop": [-1, 0, 1, 2, numbers],
"scrollamount": numbers,
"scrolldelay": numbers,
"truespeed": numbers

};

// attributes is a hash, but sometimes we want to treat it as an array-like thing.  so....
attributeList = [];
for (var prop in attributes)
  attributeList.push(prop);

function totallyRandomAttr() { 
  // Emphasize basic stuff. 
  if (rnd(3)==1) 
    return rndElt(["id", "name"]);
  return rndElt(attributeList); 
}



// Text markup

var elements = 
{
"tt": [],
"i": [],
"b": [],
"big": [],
"small": [],
"em": [],
"strong": [],
"dfn": [],
"code": [],
"samp": [],
"kbd": [],
"var": [],
"cite": [],
"abbr": [],
"acronym": [],
"br": [],
"map": [],
"q": ["cite"],
"sub": [],
"sup": [],
"span": [],
"bdo": ["dir"], // but everything can have dir, but it's required for bdo
"input": ["type", "name", "value", "checked", "disabled", "readonly", "size", "maxlength", "src", "alt", "usemap", "ismap", "tabindex", "accesskey", "accept"],
"select": ["name", "size", "multiple", "disabled", "readonly", "tabindex"],
"option": ["selected", "disabled", "label", "value"],
"optgroup": ["label", "disabled"],
"textarea": ["name", "rows", "cols", "disabled", "readonly", "tabindex", "accesskey"],
"button": ["name", "value", "type", "disabled", "tabindex", "accesskey"],
"label": ["for", "accesskey"],
"h2": [],
"ol": [],
"ul": [],
"li": [],
"dl": [],
"dd": [],
"dt": [],
"pre": ["width"], // width only in HTML 3.2
"meta": [],
"link": ["charset", "href", "hreflang", "type", "rel", "rev", "media"],
"noscript": [],
"blockquote": [],
"div": [],
"form": ["action", "method", "enctype", "accept", "name", "accept-charset"],
"hr": ["align", "noshade", "size", "width"],
"fieldset": [],
"legend": ["accesskey"],
"address": [],
"a": ["name", "href", "accesskey", "rel", "rev", "shape", "coords", "tabindex"],
"map": ["name"],
"area": ["nohref", "shape", "coords", "href", "alt", "tabindex", "accesskey"],
"img": ["src", "alt", "longdesc", "name", "height", "width", "usemap", "ismap", "hspace", "vspace", "align"], // some attributes only in HTML 3.2
// "applet": [], // don't know what attributes this has. also, way way too crashy.
"object": ["declare", "classid", "codebase", "data", "type", "codetype", "archive", "standby", "height", "width", "usermap", "name", "tabindex"],
"embed": ["src", "type", "pluginspage"], // not in DTD??
"param": ["id", "name", "value", "valuetype", "type"],
"ins": ["cite", "datetime"],
"del": ["cite", "datetime"],

// Be nice to tables; stirtable takes care of most of this stuff.
/*
"table": ["summary", "width", "border", "frame", "rules", "cellspacing", "cellpadding"],
"caption": [],
"colgroup": ["span", "width", "align", "valign"],
"col": ["span", "width", "align", "valign"],
"thead": ["align", "valign"],
"tr": ["align", "valign"],
"td": ["align", "valign", "abbr", "axis", "headers", "scope", "rowspan", "colspan"],
"th": ["align", "valign", "abbr", "axis", "headers", "scope", "rowspan", "colspan"],
*/

"base": ["href", "target"],
"meta": ["http-equiv", "name", "content", "scheme"],
"style": ["type", "media", "title"],
"script": ["charset", "type", "src", "defer", "event", "for"],
"html": [],
"head": [],
"body": ["bgcolor", "text", "link", "vlink", "alink", "background"], // attributes only in HTML 3.2

// evil, probably not in HTML 4 DTD for a good reason
"xmp": [], 
"listing": [],
"plaintext": [],

"isindex": [], // obsolete

// From HTML 3.2 only:
"s": [],
"basefont": ["size"],
"font": ["size", "color"],
"menu": [], // ???

// Everyone loves to hate...
"blink": [],
"marquee": ["behavior", "bgcolor", "direction", "height", "hspace", "loop", "scrollamount", "scrolldelay", "truespeed", "vspace", "width"],

// New things
"canvas": ["width", "height"],

// http://lxr.mozilla.org/seamonkey/source/editor/libeditor/html/nsHTMLEditUtils.cpp#585 -- i don't know what some of these are!
"dir": [],
"keygen": [],
"nobr": [],
"multicol": [],
"u": [],
"wbr": [],
"spacer": [],
"noframes": [],
"noembed": [],

// don't forget the lonely "unknown element"!
"foo": [],

// iframe
"frame": [],
"frameset": [],

};



// attributes is a hash, but sometimes we want to treat it as an array-like thing.  so....
elementList = [];
for (var prop in elements)
  elementList.push(prop);

