// === Paste output from first run here, replacing the following two lines: ===

var fuzzSettings = null;
var fuzzCommands = null;

// === End pasteover ===


var fuzzerName = "javascript: src fuzzer 3.1";
var recordStrategy = "Record as it goes";
var suggestedMaxSteps = 4000;


var allNodes;
var myRoot;
var anonymousCount; // number of anonymous children (not descendents, just children)


var HTML_NS = "http://www.w3.org/1999/xhtml";

function aC(q1, q2) { q1.appendChild(q2); }
function iB(q1, q2) { q1.parentNode.insertBefore(q2, q1); }
function rM(q1) { q1.parentNode.removeChild(q1); } // unused, but can be useful while narrowing testcases
// other things to try: clone instead of move, ...

function makeCommand()
{
  var n1index = rnd(allNodes.length), n2index = rnd(allNodes.length);
  
  var n1 = allNodes[n1index];
  var n2 = allNodes[n2index];
  
  var commandn1 = "allNodes[" + n1index + "]";
  var commandn2 = "allNodes[" + n2index + "]";

  
  switch(rnd(3)){
  case 0: 
  case 1:
    
    if(n2index > 1) { // This fuzzer avoids screwing with the root node.
  
      if (rnd(20) == 1)
        // Don't do this too often -- it tends to make things less interesting.
        return "rM(" + commandn2 + ");";
      
      if (rnd(9) == 3)
        // Don't do this too often either -- it hurts reduction and it doesn't buy us much
        return "iB(" + commandn1 + ", " + commandn2 + ");";
        
      // Do this a lot ;)
      return "aC(" + commandn1 + ", " + commandn2 + ");";
    }
    
    break;


  case 2:
/*      
      // Add an image node with a script src.

      // hopefully this will do the right thing -- allow subCommand to reference the new script node and new text node
      // This isn't all that cool; it's possible that it will cause side effects from makeCommand.   
      var oldLength = allNodes.length;
      allNodes[oldLength] = "placeholder";
      
      var subCommand = "dumpln('['); " +
                       "try{" + makeCommand() + "}catch(exx){} " +
                       "dumpln('  ]');";
                       
      // escaping twice and unescaping once: once for javascript: URL, once for sanity.
      
      return "var ns = allNodes[" + (oldLength  ) + "] = document.createElementNS(HTML_NS, 'img'); " +
             "ns.setAttribute('src', 'javascript:' + unescape('" + escape(escape(subCommand)) + "')); " +
             commandn1 + ".appendChild(ns);";
             
             // note: the script is evaluated immediately in this case, before it's part of the document!!
             */
             
  case 3:
  
    var subCommand = "dumpln('<'); " +
                       "try{" + makeCommand() + "}catch(exx){} " +
                       "dumpln('  >');";
                       
    if (n1.tagName == "object" )
      return commandn1 + ".setAttribute('data', 'javascript:' + unescape('" + escape(escape(subCommand)) + "')); ";
    else
      return commandn1 + ".setAttribute('src', 'javascript:' + unescape('" + escape(escape(subCommand)) + "')); ";
      
  }
}


function resetNodeList() {
  allNodes=[];
  anonymousCount = 0;
  var myRoot = doc.body || doc.documentElement; 
  addDOMNodes(myRoot);
}


function initFuzzerSpecific() { 
  resetNodeList();
  startFuzzing();
}

