// === Paste output from first run here, replacing the following two lines: ===

var fuzzSettings = null;
var fuzzCommands = null;

// === End pasteover ===


var fuzzerName = "MathML Element and Attribute fuzzer 3.1";
var recordStrategy = "Record as it goes";
var suggestedMaxSteps = 20000;

// dumpEachCommand = true;

var HTML_NS = "http://www.w3.org/1999/xhtml";
var MATHML_NS = "http://www.w3.org/1998/Math/MathML";


var allNodes;
var fuzzRoot;
var dirtyNodes = [];


// dumpEachCommand = true;


function aC(q1, q2) { dirtyNodes.push(q2.parentNode); q1.appendChild(q2); dirtyNodes.push(q1); }
function iB(q1, q2) { dirtyNodes.push(q2.parentNode); q1.parentNode.insertBefore(q2, q1); dirtyNodes.push(q1.parentNode); }
function rM(q1) { q1.parentNode.removeChild(q1); dirtyNodes.push(q1); }
// other things to try: clone instead of move, ...

function makeCommand()
{
  while(1){
 
  var n1index = rnd(allNodes.length), n2index = rnd(allNodes.length);
  
  var n1 = allNodes[n1index];
  var n2 = allNodes[n2index];
  
  var commandn1 = "allNodes[" + n1index + "]";
  var commandn2 = "allNodes[" + n2index + "]";
  var command;
  
  switch (rnd(9)) {
  case 0:
    if (rnd(108) == 1)
      return "bounceBody();";
  case 1:
  case 2:
  
    // Change an attribute on n1, based on n1's tagName.

    if (!n1.tagName)
      break;
      
    var attrs;

    if(elements[n1.tagName] && (rnd(5) != 1))
      attrs = elements[n1.tagName].attributes;
    else
      attrs = commonAttributes;
      
    var attr = attrs ? rndElt[attrs] : null;
    if (!attr || rnd(5) == 1) {
      attr = totallyRandomAttr();
      // dumpln("*** " + attr);
    }
      
    var value = randomThing(rnd(5) == 1 ? attributes[totallyRandomAttr()] : attributes[attr]);
    
    if (attr) {
      if (rnd(2))
        // Set it as a property.
        return commandn1 + "['" + attr + "'] = " + simpleSource(value) + ";";
      else 
        // Set it as an attribute.
        return commandn1 + ".setAttribute('" + attr + "', " + simpleSource(value) + ");";
    }
      
    break;
    
  case 3:
    // Remove an attribute on n1, based on n1's current attribute list.
    
    var attrs = n1.attributes;
    if (attrs && attrs.length) {
      var attr = rndElt(attrs).name;
      return commandn1 + ".removeAttribute('" + attr + "');";
    }
    
    break;
    
  case 4:
    // Create a new element!
    // Set some attributes on it?  Nah.
    // Place it randomly, but only rarely place it outside of the document, because that's usually boring.
    
    var tag = rndElt(elementList);
    var newIndex = allNodes.length;
    

    var createness = "var ne = document.createElementNS(MATHML_NS, '" + tag + "'); for(var i = 0; i < 3; ++i) dirtyNodes.push(ne); allNodes[" + newIndex + "] = ne; ";
    
    function isInDoc(n) { if (!n) return false; if (n.nodeType == Node.DOCUMENT_NODE) return true; return isInDoc(n.parentNode); }

    if (isInDoc(n1) != (rnd(10) == 1))
      return createness + commandn1 + ".appendChild(ne); dirtyNodes.push(" + commandn1 + "); ";
    else
      return createness + "fuzzRoot.appendChild(ne); ";

    break;

  case 5:
    if (rnd(2) == 1)
      return commandn1 + ".setAttribute('hideme', 'hide');";
    else  
      return commandn1 + ".removeAttribute('hideme');";
      
    
  case 6:

    // Want lots of testing of rowspans
    if(n1.tagName == "mtd") {
      return commandn1 + ".setAttribute('rowspan', " + randomThing(numbers) + "); " +
             commandn1 + ".setAttribute('columnspan', " + randomThing(numbers) + "); ";
    }

  case 7:
  case 8:
  
    // First: do we have elements that need more or fewer children?
  
    if (dirtyNodes.length > rnd(10)) {
      while(n = dirtyNodes.pop()) {
      
        commandnn = "allNodes[" + findInAllNodes(n) + "]";
        t = n.tagName; 
        cmd = "";

        if (t && elements[t]) {
          desiredChildren = elements[t].children;
          
          if (desiredChildren == "tok") {
            for(i=n.childNodes.length - 1; i >= 0; --i) {
              c=n.childNodes[i];
              if (c.nodeType != Node.TEXT_NODE) {
                cmd += "8; removeChildAt(" + commandnn + ", " + i + "); ";
              }
            }
            if (cmd)
              return cmd;
          }
          
          
          if (typeof desiredChildren == "number") {
          
            currentChildren = n.childNodes.length;
            
            
            function isWhitespace(s) { return !/[^\s]/.test(s); }
            
            for(i=n.childNodes.length - 1; i >= 0; --i) {
              c=n.childNodes[i]
              if (c.nodeType == Node.TEXT_NODE && isWhitespace(c.data)) {
                cmd += "removeChildAt(" + commandnn + ", " + i + "); ";
                --currentChildren;
              }
            }
            
            if(cmd) {
              // Put it back in the list of dirty nodes and come back to it later.  Too hard to do two things at once!
              // dumpln("Putting it back!");
              for(i=0;i<3;++i)
                dirtyNodes.push(n);
              return cmd;
            }
          
            if (desiredChildren < currentChildren)
              return cmd + "removeChildAt(" + commandnn + ", " + rnd(currentChildren) + ");";

            else if (desiredChildren > currentChildren) {
              var fillGapIndex = findDisconnectedElement(n);
              if (fillGapIndex != undefined)
                return cmd + "insertAsFirstChild(" + commandnn + ", allNodes[" + fillGapIndex + "]); 3;";
              else
                return cmd + "insertAsFirstChild(" + commandnn + ", createToken('mi', 'z')); 4;";
            }
            
            else if (cmd)
              return cmd;
              
          }
        } else {
          // dumpln("Unknown element! " + t);
        }
      }
    }
    
    
    
    // Move n2 in some way..
    if(n2index > 1) { // This fuzzer avoids screwing with the root node.
    
      if (rnd(100) == 300)
        // Don't do this too often -- it tends to make things less interesting, and breaks number-of-children things
        return "rM(" + commandn2 + ");";
      
      if (rnd(100) == 300)
        // Don't do this too often either -- it hurts reduction and it doesn't buy us much
        return "iB(" + commandn1 + ", " + commandn2 + ");";
        
      // Do this a lot ;)
      return "aC(" + commandn1 + ", " + commandn2 + ");";
    }
    
    break;
    
  
  }
  }
  
}


function resetNodeList() {
  allNodes = [];
  fuzzRoot = doc.body || doc.documentElement;
  addDOMNodes(fuzzRoot);
}


function initFuzzerSpecific() { 
  resetNodeList();

  var stylesheet = document.createElementNS(HTML_NS, "style");
  stylesheet.appendChild(document.createTextNode('*[hideme="hide"] { display: none }'));
  (document.body || document.documentElement).appendChild(stylesheet);

  startFuzzing();
}



function randomThing(obj)
{
  if (obj == null)
    return null;
    
  if (typeof obj == "function")
    return obj();
    
  if (typeof obj == "string")
    return obj; // not to be treated as an array :)

  if (obj.length) { // non-empty array
    var x = rndElt(obj);
    //dumpln(x);
    return randomThing(x)
  }

  if (obj.length === 0)
    return null;

  // Otherwise, it should be a number, etc.
  return obj;
}

function several(randomThingArg)
{
  return function() { 
    var num = randomThing([0, 1, [2, 4, 8, 16, 1024]]);
    var s = "";
    for (var i = 0; i < num; ++i) {
      if (i != 0)
        s += " ";
      s += randomThing(randomThingArg);
    }
    // alert(s);
    return s;
  }
}


var names =    [  "a",  "b",  "c",  "d",  "e",  "f",  "g",  "1" ];
var chars = names;
var namerefs = [ "#a", "#b", "#c", "#d", "#e", "#f", "#g", "#1" ];
var charsets = [ "UTF-8", "ISO-8859-1" ];
var URIs = [
  ["http://www.squarefree.com/", "http://www.squarefree.com/feed"], 
  ["#a", "#b"], 
  "data:text/html,", 
  ["javascript:alert(Components.classes)", "javascript:5555", "javascript:'QQQQ' + String.fromCharCode(0) + 'UUUU'"], 
  "http://www.mozilla.org/status/tree.gif"
  ];
  
  // gopher://seanm.ca/
  
var numbers = [-100, -2, -1, 0, "-0", "+0", 0.5, 1, "+1", 2, 3, 4, 5, 6, 7, 8, 9, 10 /* , 100, 1000, 4084, 8179, 8205 -- avoid hitting bug 348805 */];
function numbersWithUnits() { return rndElt(numbers) + rndElt(["px", "em", "pt", "%", ""]) }
var relations = ["alternate"];
var mimeTypes = ["text/html", "text/plain", "text/css", "text/javascript", "application/rss+xml"];
var texts = ["", "foo", "bar", "baz", "zap", "Abbey\nRoad", 'QQQQ' + String.fromCharCode(0) + 'UUUU'];
var colors = ["lime", "red", "blue", "#CCC", "#777777"];
var percents = ["0%", "-10%", "50%", "80%", "99.999%", "100%", "120%"];
var scriptcode = [// "alert('script')", 
  "var t = event.originalTarget; if(t) { dumpln('script 1 called! ' + t.tagName + ' ' + event.type); t.parentNode.removeChild(t); }",
  "var t = event.originalTarget; if(t) { dumpln('script 2 called! ' + t.tagName + ' ' + event.type); var p = t.parentNode; p.parentNode.removeChild(p); }"
  //"window.close()"
  ];
var booleans = ["true", "false"];
var tableAligns = ["top", "bottom", "center", "baseline", "axis"];
function tableAlignAttr() { return rndElt(tableAligns) + rndElt(["", " " + rndElt(numbers)]); }
var horizAligns = ["left", "center", "right"];
var lines = ["none", "solid", "dashed"];

function mpaddedAttr() { return rndElt(["+", "-", ""]) + randomThing(numbers) + rndElt(["%", "px", "em", ""]) + rndElt([" width", " height", ""]) } 

function longThing()
{
  // a string of all A's in a buffer overflow has the nice property
  // of a guaranteed crash on some architectures, IIRC
  
  var x = "A"; 
  for (var i = 0; i < 14; ++i)
    x = x + x;
  return x; 
}



var commonAttributes = ["id", "hideme", "mathbackground", "mathvariant"];


var attributes = {
"randomcrap": ["", "\0", longThing],


// From http://www.xulplanet.com/references/elemref/ref_XULElement.html
// Quite a few of these only apply to overlays, or to RDF-generated stuff.

"id": names,
"name": names,

"hideme": ["hide"],

// New in MathML 2!
"mathbackground": ["yellow", "lightgreen", "#ddd"],
"mathcolor": ["blue", "red"],
"mathsize": ["small", "normal", "big", numbersWithUnits],
"mathvariant": ["normal", "bold", "italic", "bold-italic", "double-struck", "bold-fraktur", "script", "bold-script", "fraktur", "sans-serif", "bold-sans-serif", "sans-serif-italic", "sans-serif-bold-italic", "monospace"],


// all tokens
"fontsize": numbersWithUnits,
"fontweight": ["normal", "bold"],
"fontstyle": ["normal", "italic"],
"fontfamily": ["monospace", "inherit", "serif", "sans-serif"],
"color": colors,

// mo
"form": ["prefix", "postfix", "infix"],
"fence": booleans,
"separator": booleans,
"lspace": [numbersWithUnits, mpaddedAttr], // also mpadded
"rspace": numbersWithUnits,
"stretchy": booleans,
"symmetric": booleans,
"maxsize": ["infinity", numbersWithUnits],
"minsize": numbersWithUnits,
"largeop": booleans,
"movablelimits": booleans,
"accent": booleans,

// mspace, mpadded
"width": [numbersWithUnits, mpaddedAttr],
"height": [numbersWithUnits, mpaddedAttr],
"depth": [numbersWithUnits, mpaddedAttr],

// ms
"lquote": ["&quot;", "\"", "\'"],
"rquote": ["&quot;", "\"", "\'"],


// mfrac
"linethickness": [0, 1, 2, 3, "thin", "medium", "thick"],

// mstyle
"scriptlevel": ["", "15", "+15", "+5", "-5", "+1", "-1", "3", numbers],
"displaystyle": booleans,
"scriptsizemultiplier": ["0.71", numbers],
"scriptminsize": numbersWithUnits,
"background": [colors, "transparent"],

// mfenced
"open": ["<", "(", "[", "{", "|", "f", ""],
"close": ["<", "(", "[", "{", "|", "g", ""],
"separators": [",", "", ";", ",;"],

// msub, msup
"subscriptshift": numbersWithUnits,
"superscriptshift": numbersWithUnits,

// mover, munder
"accent": booleans,
"accentunder": booleans,

// mtable
"align": tableAlignAttr,
"rowalign": several(tableAligns),
"columnalign": horizAligns,
// "groupalign": [groupAlignmentListList, groupAlignmentList], // list of lists for mtable, fewer for mtr or mtd
"alignmentscope": several(booleans),
"rowspacing": numbersWithUnits,
"columnspacing": numbersWithUnits,
"rowlines": several(lines),
"columnlines": several(lines),
"frame": lines,
"framespacing": function() { return randomThing(numbersWithUnits) + " " + randomThing(numbersWithUnits); },
"equalrows": booleans,
"equalcolumns": booleans,
"displaystyle": booleans,

"rowspan": [[0, 2], numbers],
"columnspan": [[0, 2], numbers],




"lastone": []

};



function createToken(tag, text)
{
  var e = document.createElementNS(MATHML_NS, tag); 
  e.appendChild(document.createTextNode(text));
  return e;
}

// When creating new non-token elements, fill them with new tokens, I guess.

var elements = 
{
  "maligngroup": { children: 0,        attributes: ["groupalign"] },

  // tokens
  "malignmark":  { children: 0,        attributes: [] },
  "mi":          { children: "tok",    attributes: ["fontsize", "fontweight", "fontstyle", "fontfamily", "color"] },
  "mn":          { children: "tok",    attributes: ["fontsize", "fontweight", "fontstyle", "fontfamily", "color"] },
  "mtext":       { children: "tok",    attributes: ["fontsize", "fontweight", "fontstyle", "fontfamily", "color"] },
  "ms":          { children: "tok",    attributes: ["fontsize", "fontweight", "fontstyle", "fontfamily", "color",
                                                "lquote", "rquote"] },
  "mspace":      { children: "tok",    attributes: ["fontsize", "fontweight", "fontstyle", "fontfamily", "color",
                                                "width", "height", "depth"] },
  "mo":          { children: "tok",    attributes: ["fontsize", "fontweight", "fontstyle", "fontfamily", "color",
                                                "form", "fence", "separator", "lspace", "rspace", "stretchy", "symmetric", 
                                                "maxsize", "minsize", "largeop", "moveablelimits", "accent"] },

  "mrow":        { children: "normal", attributes: [] },
  "mfrac":       { children: 2,        attributes: ["linethickness"] },
  "msqrt":       { children: "normal", attributes: [] },
  "mroot":       { children: 2,        attributes: [] },
  "mstyle":      { children: "normal", attributes: ["scriptlevel", "displaystyle", "scriptsizemultiplier", "scriptminsize", "color", "background"] },
  "merror":      { children: "normal", attributes: [] },
  "mpadded":     { children: "normal", attributes: ["width", "lspace", "height", "depth"] },
  "mphantom":    { children: "normal", attributes: [] },
  "mfenced":     { children: "normal", attributes: ["open", "close", "separators"] },
  "msub":        { children: 2,        attributes: ["subscriptshift"] },
  "msup":        { children: 2,        attributes: ["superscriptshift"] },
  "msubsup":     { children: 3,        attributes: ["subscriptshift", "superscriptshift"] },
  "munder":      { children: 2,        attributes: ["accentunder"] },
  "mover":       { children: 2,        attributes: ["accent"] },
  "munderover":  { children: 3,        attributes: ["accent", "accentunder"] },
  "mmultiscripts": { children: "ms",   attributes: [] },
  "mtable":      { children: "normal", attributes: ["align", "rowalign", "columnalign", "groupalign", "alignmentscope", "rowspacing", "columnspacing", "rowlines", "columnlines", "frame", "framespacing", "equalrows", "equalcolumns", "displaystyle"] },
  "mtr":         { children: "normal", attributes: ["rowalign", "columnalign", "groupalign"] },
  "mtd":         { children: "normal", attributes: ["rowspan", "columnspan", "rowalign", "columnalign", "groupalign"] },
  
  "emptyset":    { children: 0,        attributes: [] }, // one of the few content tags that has an obvious effect...


  "maction":     { children: "normal", attributes: [] }, // not sure about children for this element...

  "foo":         { children: "normal", attributes: [] },
};




// attributes is a hash, but sometimes we want to treat it as an array-like thing.  so....
attributeList = [];
for (var prop in attributes)
  attributeList.push(prop);

function totallyRandomAttr() { 
  // Emphasize basic stuff. 
  if (rnd(3)==1) 
    return rndElt(["id", "name"]);
  return rndElt(attributeList); 
}
// attributes is a hash, but sometimes we want to treat it as an array-like thing.  so....
elementList = [];
for (var prop in elements)
  elementList.push(prop);




// MathML is special: many elements have a specified number of children!
// Here's my solution: except rarely, don't touch other than by *swapping* elements.  BUT record a lot of information in the swapping:
//   Suppose n1 and n2 are being swapped.
//   Then we'll actually record rCA(p1, i1, n2) and rCA(p2, i2, n1).
// That doesn't quite work, because the first rCA makes n2 disappear from p2's child list, making the second rCA place it in the wrong place :(
/*
  function rCA(parent, index, newChild) {
    var oldChild = parent.childNodes[index];
    if (oldChild)
      parent.replaceChild(newChild, oldChild);
    else
      parent.appendChild(newChild); // not quite right if multiple children are missing, but close enough for now
  }
*/

/*
function swapNodes(n1, n2)
{
  p1 = n1.parentNode;
  s1 = n1.nextSibling;
  
  p2 = n2.parentNode;
  s2 = n2.nextSibling;
  
  // There are many tricky cases!
  
  if (p1 == p2)
    // tricky
    
  
  else {
    p2.insertBefore(n1, s2);
    p1.insertBefore(n2, s1);
  }
  
}
*/



  function findInAllNodes(n) {
    for (var i=0; i<allNodes.length; ++i)
      if (allNodes[i] == n)
        return i;
  }
  
function insertAsFirstChild(p, n)
{
  p.insertBefore(n, p.firstChild);
}

function removeChildAt(p, i)
{
  var n = p.childNodes[i];

/*
  // This check only makes sense in the initial run, not while reducing something that has been recorded!
  if (typeof n == "undefined")
    alert("Squid " + i);
*/

  p.removeChild(n);
}

function bounceBody()
{
  // This was originally a workaround for bug 325513, but I'm keeping it even though it was fixed.

  var b = document.body || document.documentElement;
  var p = b.parentNode;
  p.removeChild(b); 
  p.appendChild(b); 
}


/*  
  function findInChildList(p, n) {
    for (var i=0; i<p.childNodes.length; ++i)
      if (p.childNodes[i] == n)
        return i;
  }
*/

// Ok, I give up on all that.  Instead, I'll call fCC(n1) -- fix child count.
// rCA is nice, though, for stable reductions and so we're not always tacking things onto the end.
// i think i'll use rCA to move n2 to a new happy home.  if it previously had a position and that position needs to be filled, fill it in with (A) createToken or (B) something that's *already* floating freely (in allNodes but without a parent), and that isn't n2.  or have a "last bumped element" (i don't think that would work).

// how bad would it be to always replace n2's void with createToken?  if the tokens aren't added to allNodes, maybe it wouldn't be too bad.  and the potentially more interesting behavior of grabbing something "free" from allNodes (or a separate list?) can always be added later.

// you know what? screw all that.  let's get the attributes in.

// look out for the "node list" vs. "argument list" thing.
  
  
/*

      //var n1children;
      var n2children;

      //if (elements[n1.tagName] && typeof(elements[n1.tagName].children) == "number")
      //  n1children = elements[n1.tagName].children;
        
      if (rnd(2) || (n2.parentNode && elements[n2.parentNode.tagName] && typeof(elements[n2.parentNode.tagName].children) == "number")
                 || (n1.parentNode && elements[n1.parentNode.tagName] && typeof(elements[n1.parentNode.tagName].children) == "number")
                 ) {
        // We should only (or decided to) move n2 by swapping it with n1 (because n2's parent OR n1's parent is special)


        dump("Making swap command");
        
        n1parent = n1.parentNode;
        n2parent = n2.parentNode;
        
        if (n1parent) {
          n1parentIndex = findInAllNodes(n1parent);
          n1childIndex = findInChildList(n1parent, n1);
        }
        
        if (n2parent) {
          n2parentIndex = findInAllNodes(n2parent);
          n1childIndex = findInChildList(n2parent, n2);
        }
        
        var cmd = "";
        
        if (n1parent)
          cmd += "rCA(allNodes[" + n1parentIndex + "], " + n1childIndex + ", " + commandn2 + "); ";
          
        if (n2parent)
          cmd += "rCA(allNodes[" + n2parentIndex + "], " + n2childIndex + ", " + commandn1 + "); ";
          
        
        
        
        
        
      }
        
        
      dumpln("Other movement");
        
*/

            function findDisconnectedElement(notMe) {
              for (var i=0; i<allNodes.length; ++i)
                if (allNodes[i] && allNodes[i].nodeType == Node.ELEMENT_NODE && allNodes[i] != notMe && !(allNodes[i].parentNode))
                  return i;
            }
            
