// === Paste output from first run here, replacing the following two lines: ===

var fuzzSettings = null;
var fuzzCommands = null;

// === End pasteover ===


var fuzzerName = "Mutation event fuzzer 3.1";
var recordStrategy = "Special";
var suggestedMaxSteps = 500; // reduction takes forever AND is a royal pain!


var allNodes;
var myRoot;
var anonymousCount; // number of anonymous children (not descendents, just children)



function resetNodeList() {
  allNodes=[];
  anonymousCount = 0;
  // var myRoot = doc.body || doc.documentElement; 
  var myRoot = doc.documentElement;
  addDOMNodes(myRoot, false, false, true);
}


function initFuzzerSpecific()
{
  resetNodeList();

  doc.addEventListener("DOMNodeInserted", runpeekc("inserted"), false);
  doc.addEventListener("DOMNodeRemoved", runpeekc("removed"), false);
  doc.addEventListener("DOMAttrModified", runpeekc("attrmodified"), false);
  
  startFuzzing();
}



// yay currying
function runpeekc(key){ return function(ev) { 
  // if (ev.originalTarget &&  ev.originalTarget.tagName && ev.originalTarget.tagName.indexOf("nativescrollbar") != -1) { /* avoid triggering 338674 */ }
  // else { 
    runpeek(key);
  // }
} }

// stack cells look like { t: thisStep, n: nextStackCell }

var stacktop = null;

function runpeek(key)
{
  if (stacktop) {
    var u = stacktop.t[key];
    if (u)
      doCommand(u); // this reuses doCommand!
  }
}

doCommand = function (step)
{
  push(step);
  try {
    step.fun();
  }
  catch(e) {
    // alert("execStep -- " + e);
  }
  pop(step);
}

function push(step)
{
  // alert("Pushing " + step.origCount);
  stacktop = { t:step, n:stacktop };
}

function pop()
{
  // alert("Popping " + stacktop.t.origCount);
  stacktop = stacktop.n;
}

var depth = 0;


/*
xlink:href is here to test
http://bonsai.mozilla.org/cvsblame.cgi?file=mozilla/content/base/src/nsGenericElement.cpp&rev=3.477#1865, which is very much called during mutation fuzzing
*/
var attrs = [
  [null, "style", ["border: 1px solid red; float: right;","display:block; border: 1px solid green", "display:inline; border:1px solid blue"]],
  ["http://www.w3.org/1999/xlink", "href", ["http://www.mozilla.org/",""]],
  [null, "href", ["http://www.squarefree.com/",""]],
  [null, "id", ["foopy", "loopy", "noopy", ""]],
  [null, "name", ["foopy", "loopy", "noopy", ""]]
];

function makeSubCommand()
{
  var n1index = rnd(allNodes.length), n2index = rnd(allNodes.length);
  
  var n1 = allNodes[n1index];
  var n2 = allNodes[n2index];
  
  var commandn1 = "allNodes[" + n1index + "]";
  var commandn2 = "allNodes[" + n2index + "]";
  
  /*
  if (rnd(500) == 1) {
    // Quite evil, and quite slow.  I think the idea is to get things that were removed from the document to be garbage-collected quickly.
    // (Even more effective would be to use rM as destroy...
    // This is really frustrating when reducing, and I don't call a garbage-collection
    // routine, so I've commented it out entirely.
    return makeSubCommand() + "document.documentElement.normalize(); resetNodeList(); ";
  }
  */


  if (rnd(120) == 3) {
    return commandn1 + ".normalize(); "; // barely tested!
  }

/*  
  if (rnd(600) == 1) {
    return "rMDestroy(" + commandn1 + "); " + commandn1 + " = null; resetNodeList(); "; // seriously get rid of it.
  }
*/

  if (rnd(2) == 1) {
    if (rnd(2) == 1 || n1 == myRoot) { 
      return "aC(" + commandn1 + ", " + commandn2 + "); ";
    } else {
      return "iB(" + commandn1 + ", " + commandn2 + "); ";
    }
  }
  else {
    var attr = rndElt(attrs);
    
    if(rnd(2) == 1)
      return commandn1 + ".setAttributeNS(" + simpleSource(attr[0]) + ", '" + attr[1] + "', '" + rndElt(attr[2]) + "');";
    else
      return commandn1 + ".removeAttributeNS(" + simpleSource(attr[0]) + ", '" + attr[1] + "');";
  }

}

function rMDestroy(q1)
{
  rM(q1);
  tearApart(q1);
}

function tearApart(n)
{
  while (n.firstChild) {
    tearApart(n.firstChild);
    n.removeChild(n.firstChild);
  }
}
  


function aC(q1, q2) { q1.appendChild(q2); }
function iB(q1, q2) { q1.parentNode.insertBefore(q2, q1); }
function rM(q1) { q1.parentNode.removeChild(q1); } // unused, but can be useful while narrowing testcases


function makeCommand()
{
  return makeStepObj(2);
}

function makeStepObj(depthLeft)
{
  var u = {};
  
  // u.origCount = ++count;
  u.fun = new Function(makeSubCommand());

  if (depthLeft) {
    // Removed appears to be called before inserted (when both are called), so put removed first.
    if (rnd(3)) u.removed = makeStepObj(depthLeft - 1);
    if (rnd(3)) u.inserted = makeStepObj(depthLeft - 1);
    if (rnd(3)) u.attrmodified = makeStepObj(depthLeft - 1);
  }
  
  return u;
}


/*************
 * RECORDING *
 *************/

function recordFunsSpecial()
{  
  // Use an object instead of an array to be more Lithium-friendly.

  var a = {};
  for (var r=0; r<maxSteps; ++r)
    a["r" + r] = makeCommand();
  
  var output =
    "var fuzzSettings = " + fuzzSettings.toSource() + ";\n" +
    "var fuzzCommands = " + serializeObj(a) + ";";

  giveToCopy(output);
}



/************
 * PLAYBACK *
 ************/

var playbackIndex = 0;
var playbackProps = [];

function playFunsSpecial()
{
  for (var p in fuzzCommands)
    playbackProps.push(p);
    
  play();
}

function play()
{
  // This isn't quite right... want chunking.

  if (playbackProps[playbackIndex] != null) {

    var step = fuzzCommands[playbackProps[playbackIndex]];
  
    window.status = playbackProps[playbackIndex];
  
    if(step)
    {
      doCommand(step);
      if (stacktop != null)
        alert(stacktop);
    }

    ++playbackIndex;
    setTimeout(play, 20); // ignore interval, since we ignore chunking
  }
}





/*************************
 * SPECIAL SERIALIZATION *
 *************************/
 
// This serialization is intended to work well with Lithium's TIY mode, when "fuzzCommands" is an object with e.g. "command100: ..." instead of an array.

function serializeInternal(o, indent)
{
  if (typeof o == "object")
    return serializeObjInternal(o, indent);

  return uneval(o);
}

function serializeObjInternal(o, indent)
{
  var s = "({\n";
  var indent2 = indent + "  ";
  for (var prop in o)
    s += indent2 + prop + ": " + serializeInternal(o[prop], indent2) + ",\n";
  s += indent + "})";
  return s;
}

function serializeObj(o) { return serializeObjInternal(o, ""); }

function serializeArray(a) {
  var s = "[\n";
  for (var i in a)
    s += "  " + serializeObjInternal(a[i], "  ") + ",\n\n";
  s = s.substr(0, s.length - 3);
  s += "\n]";
  return s;
}




/**************
 * FORCING GC *
 **************/

// Stolen from Bob Clary.  Requires Venkman to be installed, and requires being able to get privs.
function collectGarbage()
{
  try
  {
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
  }
  catch(ex)
  {
    // alert("collectGarbage: privilege failure " + ex);
    // throw 0;
    return;
  }

  try
  {
    var JSD_CTRID = "@mozilla.org/js/jsd/debugger-service;1";
    var jsdIDebuggerService = Components.interfaces.jsdIDebuggerService;
    gJSDebuggerService = Components.classes[JSD_CTRID].
      getService(jsdIDebuggerService);
    gJSDebuggerService.GC();
  }
  catch(ex)
  {
    alert("colllectGarbage: other failure, possibly because Venkman isn't installed: " + ex);
    throw 0;
  }
}
