// === Paste output from first run here, replacing the following two lines: ===

var fuzzSettings = null;
var fuzzCommands = null;

// === End pasteover ===


var fuzzerName = "New Script Node fuzzer 3.1";
var recordStrategy = "Record as it goes";
var suggestedMaxSteps = 4000;


var allNodes;
var myRoot;
var anonymousCount; // number of anonymous children (not descendents, just children)


var HTML_NS = "http://www.w3.org/1999/xhtml";

function aC(q1, q2) { q1.appendChild(q2); }
function iB(q1, q2) { q1.parentNode.insertBefore(q2, q1); }
function rM(q1) { q1.parentNode.removeChild(q1); } // unused, but can be useful while narrowing testcases
// other things to try: clone instead of move, ...

function makeCommand()
{
  var n1index = rnd(allNodes.length), n2index = rnd(allNodes.length);
  
  var n1 = allNodes[n1index];
  var n2 = allNodes[n2index];
  
  var commandn1 = "allNodes[" + n1index + "]";
  var commandn2 = "allNodes[" + n2index + "]";

  
  switch(rnd(3)){
    case 0: 
      return "aC(" + commandn1 + ", " + commandn2 + ");";
    case 1:
      if (n1 > 2 && n2 > 2)
        return "iB(" + commandn1 + ", " + commandn2 + ");";
      return "1";
    case 2:
      
      // Add a virgin script node with a script in it.

      // hopefully this will do the right thing -- allow subCommand to reference the new script node and new text node
      // This isn't all that cool; it's possible that it will cause side effects from makeCommand.   
      var oldLength = allNodes.length;
      allNodes[oldLength] = "placeholder";
      allNodes[oldLength+1] = "placeholder";
      
      var subCommand = "dumpln('['); " +
                       "try{" + makeCommand() + "}catch(exx){} " +
/*
// Two commands inside the script?  A bit messy and probably won't catch more bugs, at least not yet.
                       "dumpln(' -'); " +
                       "try{" + makeCommand() + "}catch(exx){} " +
*/
                       "dumpln('  ]');";
      
      return "var ns = allNodes[" + (oldLength  ) + "] = document.createElementNS(HTML_NS, 'script'); " +
             "var nt = allNodes[" + (oldLength+1) + "] = document.createTextNode(unescape('" + escape(subCommand) + "')); " +
             "ns.appendChild(nt); " +
             commandn1 + ".appendChild(ns);";
      

    case 3:
/*
      // Add a virgin script node with src

      // hopefully this will do the right thing -- allow subCommand to reference the new script node and new text node
      // This isn't all that cool; it's possible that it will cause side effects from makeCommand.   
      var oldLength = allNodes.length;
      allNodes[oldLength] = "placeholder";
      
      var subCommand = "dumpln('>'); try{" + makeCommand() + "}catch(exx){} dumpln(' <');";
      
      return "var ns = allNodes[" + (oldLength  ) + "] = document.createElementNS(HTML_NS, 'script'); " +
             // Escaping serves two purposes at once: (1) don't break the string with line breaks; (2) data: URLs need it.
             "ns.src = 'data:text/javascript," + escape(subCommand) + "';" +
             commandn1 + ".appendChild(ns);";
*/


  }

 // The next thing to try is inserting <script src>, with fast stuff (using data URLs) and slow stuff (using hixie's delay script)


}


function resetNodeList() {
  allNodes=[];
  anonymousCount = 0;
  var myRoot = doc.body || doc.documentElement; 
  addDOMNodes(myRoot);
}


function initFuzzerSpecific() { 
  resetNodeList();
  startFuzzing();
}

