// === Paste output from first run here, replacing the following two lines: ===

var fuzzSettings = null;
var fuzzCommands = null;

// === End pasteover ===


var fuzzerName = "Random Classes 3.1";
var recordStrategy = "Record without doing";
var suggestedMaxSteps = 1000; // very active fuzzer! and reductions are hard enough.

// Based on the CSSGen list, which was in turn based on the Random Styles list.
var CSSProperties = [
  {
    prop: "float",
    values: ["left", "right", "none"]
  },
  {
    prop: "clear",
    values: ["none", "left", "right", "both"]
  },
  {
    prop: "-moz-float-edge",
    values: ["content-box", "border-box", "padding-box", "margin-box", "inherit"]
  },
  
  {
    prop: "display",
    values: ["inline", "block", "inline-block", "inline-table", "-moz-inline-block", "list-item",
    // Table
    "table", "table-row-group", "table-header-group", "table-footer-group", "table-row", "table-column-group",
    "table-column", "table-cell" // , "table-caption" -- avoid hitting bug 348126
    // XUL
    // , "-moz-box", "-moz-inline-grid", "-moz-grid", "-moz-box", "-moz-inline-box", "-moz-grid-group", "-moz-grid-line", "-moz-stack", "-moz-inline-stack", "-moz-deck", "-moz-popup", "-moz-groupbox"
    ]
  },
  {
    prop: "visibility",
    values: ["visible", "hidden", "collapse"]
  },
  {
    prop: "position",
    values: ["static", "relative", "absolute", "fixed"]
  },
  {
    prop: "overflow",
    values: ["visible", "scroll", "hidden", "auto", "-moz-scrollbars-horizontal", "-moz-scrollbars-none", "-moz-scrollbars-vertical", "-moz-hidden-unscrollable"]
  },
  {
    prop: "color",
    values: ["red", "green", "blue", "black"]
  },
  {
    prop: "background",
    values: ["transparent", "#fcd", "url(http://www.google.com/images/logo_sm.gif)", "url(https://bugzilla.mozilla.org/attachment.cgi?id=165273&action=view)"]
  },
  {
    prop: "width",
    values: ["20em", "1px", "auto", "10%", "200%"]
  },
  {
    prop: "height",
    values: ["2em", "100px", "auto", "10%", "200%"]
  },
  
  {
    prop: "content",
    values: [
    
     "'generated'", 
     "'generated generated generated generated generated generated generated generated generated generated generated generated generated generated generated generated generated generated generated generated generated generated generated generated generated generated generated generated generated generated generated'", 
     "url(http://www.mozilla.org/images/mozilla-16.png)", 
     "url(https://bugzilla.mozilla.org/attachment.cgi?id=165273&action=view)",


// Multiline generated content triggers some special code in Gecko, so let's lets it well!

// inspired by uri's attachment in bug 343540. the amount of escaping here is ludicrous; one level of backslashes is for this being a string and the other is for it being eval'ed as a string later.  (except that was somehow too much escaping, wtf?)

// why so many zeroes? "If a character in the range [0-9a-fA-F] follows the hexadecimal number, the end of the number needs to be made clear. There are two ways to do that... (2) by providing exactly 6 hexadecimal digits."

     "'XXX-\\00000aYYY'", 
     "'XXX\\00000aYYY'",
     "'A\\00000aB\\00000aC\\00000aD\\00000aE'",
     "'a \\00000ab \\00000ac \\00000ad \\00000ae'",
     "attr(id)",
     "open-quote",
     "close-quote",
     "no-open-quote",
     "no-close-quote",
     "counters(chicken, ' ... ', decimal) ' '",
     "counter(chicken)",
     "counter(chicken)",
     "counter(chicken)",
     "counter(chicken)",
     "counter(chicken)",
     "counter(chicken)",
     "counter(chicken)",
     "counter(egg)",
     "counter(egg)",
    ]
  },
  {
    prop: "quotes",
    values: ["none", "'open' 'close'", "'>>' '<<'", "'<1>' '</1>' '<2>' '</2>'"]
  },
  {
    prop: "list-style-type",
    values: ["none", "inherit", "hebrew", "disc", "upper-roman"]
  },
  {
    prop: "list-style-position",
    values: ["inside", "outside", "inherit"]
  },
  {
    prop: "counter-reset",
    values: ["chicken", "egg", "chicken 3", "chicken 11 egg"]
  },

  {
    prop: "counter-increment",
    values: ["chicken", "egg", "chicken 5", "chicken -1 egg"]
  },

  {
    prop: "padding",
    values: ['0','10px','2em','100px','3pt','auto']
  },
  {
    prop: "margin",
    values: ['0','10px','2em','100px','3pt','auto']
  },
  {
    prop: "opacity",
    values: ["0.2", "1"]
  },
  {
    prop: "z-index",
    values: ["inherit", "5", "0", "-200"]
  },

  {
    prop: "letter-spacing",
    values: ["4em", "inherit", "1px"]  // , "-2px", "-1em", "-2em" trigger bug 334107 too frequently
  },
  {
    prop: "text-align",
    values: ["left", "right", "justify"]
  },

  // Bidi stuff
  { 
    prop: "unicode-bidi",
    values: ["normal", "embed", "bidi-override", "inherit"]
  },
  {
    prop: "direction",
    values: ["inherit", "ltr", "rtl"]
  },
  
  // Table stuff
  {
    prop: "border-collapse",
    values: ["inherit", "collapse"]
  },
  {
    prop: "caption-side",
    values: ["top", "bottom", "right", "left", "inherit"]
  },
  {
    prop: "empty-cells",
    values: ["inherit", "show"]
  },
  {
    prop: "table-layout",
    values: ["fixed", "auto"]
  },
  
  {
    prop: "outline",
    values: ["1px solid yellow", "none"]
  },
  {
    prop: "font-size",
    values: ["130%", "80%"]
  },
  
  { prop: "top", values: ["20em", "-20em", "0", "10%", "5px", "-5px"] },
  { prop: "bottom", values: ["20em", "-20em", "0", "10%", "5px", "-5px"] },
  { prop: "right", values: ["20em", "-20em", "0", "10%", "5px", "-5px"] },
  { prop: "left", values: ["20em", "-20em", "0", "10%", "5px", "-5px"] },

  {
    prop: "white-space",
    values: ["inherit", "normal", "pre", "-moz-pre-wrap", "nowrap"]
  }
  // ,
  
  
  // Column stuff is commented out due to frequent crashes.
/*
  {
    prop: "-moz-column-count",
    values: ["-1", "0", "1", "2", "3", "15"]
  },
  {
    prop: "-moz-column-width",
    values: ["20em", "1px", "auto", "10%", "200%"]
  },
  {
    prop: "-moz-column-gap",
    values: ["20em", "1px", "auto", "10%", "200%"]
  },
*/



];

var pseudoElements = [ ":after", ":before", ":first-letter", ":first-line", "::-moz-selection", "::-moz-focus-inner", "::-moz-focus-outer", "::-moz-list-bullet", "::-moz-list-number", "::-moz-hframeset-border", "::-moz-vframeset-border",

/* The following are from nsCSSAnonBoxList.h in Mozilla source code.  ::-moz-column-content is known to work for color and visibility! */
// Commented out because I think bug 331883 took care of these.
// "::-moz-non-element", "::-moz-anonymous-block", "::-moz-anonymous-positioned-block", "::-moz-first-line-fixup", "::-moz-line-frame", "::-moz-buttonlabel", "::-moz-cell-content", "::-moz-dropdown-list", "::-moz-fieldset-content", "::-moz-frameset-blank", "::-moz-radio", "::-moz-checkbox", "::-moz-display-comboboxcontrol-frame", "::-moz-table", "::-moz-table-cell", "::-moz-table-column-group", "::-moz-table-column", "::-moz-table-outer", "::-moz-table-row-group", "::-moz-table-row", "::-moz-canvas", "::-moz-pagebreak", "::-moz-page", "::-moz-pagecontent", "::-moz-page-sequence", "::-moz-scrolled-content", "::-moz-scrolled-canvas", "::-moz-scrolled-page-sequence", "::-moz-column-content", "::-moz-viewport", "::-moz-viewport-scroll", "::-moz-select-scrolled-content", "::-moz-tree-column", "::-moz-tree-row", "::-moz-tree-separator", "::-moz-tree-cell", "::-moz-tree-indentation", "::-moz-tree-line", "::-moz-tree-twisty", "::-moz-tree-image", "::-moz-tree-cell-text", "::-moz-tree-checkbox", "::-moz-tree-progressmeter", "::-moz-tree-drop-feedback", "::-moz-math-stretchy", "::-moz-math-anonymous", "::-moz-math-inline"
 ];


// I don't think the strategy of using CSS on an attribute called "class" works for MathML :(
// Could use IDs in the same way I currently use classes, but that seems hacky and messy.
var classes = [ "cat", "toad", "zebra", "lizard", "penguin", "elephant" ];


function randomSelector() {
  var selector;
  
  if (rnd(30) == 0)
    selector = "*";
  else
    selector = "." + rndElt(classes);

  if (rnd(2) == 0)
    selector += rndElt(pseudoElements);

  return selector;
}

function randomRule() {
  var rule = randomSelector() + " { ";
  var i, pair;
  for (i = 0; pair = CSSProperties[i]; ++i)
    if (rnd(11) == 0)
      rule += pair.prop + ": " + rndElt(pair.values) + "; ";
  rule += "}";
  return rule;
}

function randomStylesheet()
{
  // Just one rule per stylesheet for now.
  var s = "";
  for (var i = 0; i < 1; ++i)
    s += randomRule();
  return s;
}

function makeCommand()
{
  switch(rnd(2)) {
    case 0:
      // Change one of several stylesheets.
      return "setTextContent(stylesheets[" + rnd(stylesheets.length) + "], " + simpleSource(randomStylesheet()) + ");";
    default:
      // Change a random node's class.
      // return "allElements[" + rnd(allElements.length) + "].className = " + simpleSource(rndElt(classes)) + ";";
      return "allElements[" + rnd(allElements.length) + "].setAttribute('class', " + simpleSource(rndElt(classes)) + ");";
  }
}

function setTextContent(n, s)
{
  // Safari sucks, so we can't use foo.textContent.
  while (n.firstChild)
    n.removeChild(n.firstChild);
    
  addTextContent(n, s);
}

function addTextContent(n, s)
{
  n.appendChild(doc.createTextNode(s));
}

var stylesheets = [];

var allElements = [];

function addElements(n) {

  if (n.tagName && n.tagName.toLowerCase().indexOf("script" != -1) && n.getAttribute("id") && n.getAttribute("id").indexOf("fuzz") != -1) {
    if (n.previousSibling && n.previousSibling.nodeType == Node.TEXT_NODE)
      alert("Warning: fuzz script found with a whitespace node before it.  This could affect node counts.");
    return;
  }

  
  // MathML does not expose style, also doesn't use class attribute the way i want
  /*
  try { 
    if (n.style)
      allElements.push(n);
  } catch(e) { }
  */
  
  allElements.push(n);

  var i,c;
  for (i=0;c=n.childNodes[i];++i)
    if (c.nodeType == Node.ELEMENT_NODE)
      addElements(c);
};

function initFuzzerSpecific()
{
  var myRoot = doc.getElementsByTagName("body")[0] || doc.documentElement; 
  addElements(myRoot);

  var myStylesheetHolder = doc.getElementsByTagName("head")[0] || myRoot;

  for (var i = 0; i < 25; ++i) {
    var s = doc.createElementNS("http://www.w3.org/1999/xhtml", 'style');
    s.style.display = "none";
    myStylesheetHolder.appendChild(s);
    stylesheets.push(s);
  }
  
  startFuzzing();
}
