// === Paste output from first run here, replacing the following two lines: ===

var fuzzSettings = null;
var fuzzCommands = null;

// === End pasteover ===


var fuzzerName = "Random JS 3.1";
var recordStrategy = "Record as it goes"; // because this fuzzer depends heavily on previous steps when figuring how what objects to explore
dumpEachCommand = true; // because autofuzz keeps finding bugs in pages that for unknown reasons cause randomjs to be non-deterministic, at least on a macbook pro :(  and also because chosenFuzzer gets in the way when using autofuzz.

//dumpEachSeed = true;
var suggestedMaxSteps = 4000; // sparse activity, but gets more boring as it goes on, and don't want to be so much slower than the other fuzzers.  non-determinism really sucks.


function initFuzzerSpecific() { randomJS(); randomJS.init(); }
function makeCommand() { return randomJS.makeCommand(); }


// This script takes advantage of two facts about scoping in JavaScript:
//   * eval() inherits scope.
//   * new Function() does not inherit scope.
// So we use new Function() when executing scripts, and eval when a user calls randomJS.evalInScope explicitly.
// This isn't too important, since the reflection doesn't go into randomJS anyway.
// Most variables and functions related to Random JS are kept in a closure :)

// knownObjects initially contains window, document, document.documentElement, document.body, and all descendants of the body.
// It grows slowly as the script runs -- whenever the script discovers a new object by poking at object properties or examining funciton return values.
var knownObjects;

// Known ways in which this script is suicidal:
// * If it manages to do Object.prototype.__defineGetter__("foopy", ...), then when
//   it checks propertyBlacklist["foopy"] the next time around, it gets hit ;(

function reportError(er)
{
  // dump('/// ' + rjscount + " " + er + '\n');
}

if (!("dump" in this))
  dump = function() { };

var rjscount = 0;

/*
function prune()
{
  var knownObjects2 = [];
  for(var i=0; i<knownObjects.length; i+=5) {
    var n = knownObjects[i];
    if (typeof n != "string" && typeof n != "number")
      knownObjects2.push(n);
  }
  knownObjects = knownObjects2;
}
*/

function pruneRandomly()
{
  // With this method of pruning, some objects are more likely to survive than others.  Hmm.
  
  var jump = rnd(91) + 10; // before, it was always 18.  now it's between 10 and 100.

  dump("Before a random prune: " + knownObjects.length + "\n");
  var knownObjects2 = [];
  for(var i=0; i<knownObjects.length; i+=rnd(jump)+1) {
    var n = knownObjects[i];
    if (typeof n != "string" && typeof n != "number")
      knownObjects2.push(n);
  }
  knownObjects = knownObjects2;
  dump("After a random prune: " + knownObjects.length + "\n");
}



function randomJS(){

// For manual use:

// Evaluate any javascript in the randomJS scope (closure).
randomJS.evalInScope =
  function(e) { return eval(e); };

// See what kinds of things knownObjects contains.
randomJS.dumpAll = 
  function() { for(var i = 0; i<knownObjects.length; ++i) try { dump(i + " " + (typeof knownObjects[i]) + ": " + knownObjects[i] + "\n"); } catch(e) { dump(i + " ERROR " + e + "\n"); } };

// Notices if something is not enumerable, or if enumerating something crashes.
randomJS.dumpAllProps =
  function() { javascript:for(var i = 0; i<knownObjects.length; ++i) { dump(i + " "); for (var j in knownObjects[i]) dump(j + " "); dump("\n"); } }; 


var myRoot;
var anonymousCount; // number of anonymous children (not descendents, just children)




var propertyBlacklist = {
  // things with known bugs
  "setUserData":              1, // bug 324871, leak
  "menu":                     1, // bug 326864, crash
  "showPopup":                1, // bug 326877, annoyance
  "unsuspendRedraw":          1, // bug 327706, assertion
  "animatedPathSegList":      1, // bug 327709, assertion
  "createSVGTransformFromMatrix": 1, // bug 327756, assertion
  "length":                   1, // bug 346268, hang
  "renameNode":               1, // regression from bug 47903, https://bugzilla.mozilla.org/show_bug.cgi?id=47903#c58

  // "not yet implemented" shouldn't be an assertion! (bug 303500)
  "isEqualNode":              1,
  "farthestViewportElement":  1, // GetF... or SetF... in c++ code
  "nearestViewportElement":   1,
  "contentStyleType":         1, 
  "contentScriptType":        1,
  "getCurrentTime":           1,
  "isSupported":              1,

  // "not yet implemented" in svg
  "rotateFromVector":         1,
  "lengthAdjust":             1,
  "textLength":               1,
  "flipX":                    1,
  "flipY":                    1,
  "useCurrentView":           1,
  "currentView":              1,
  "selectSubString":          1,
  "pauseAnimations":          1,
  "unpauseAnimations":        1,
  "rotate":                   1,
  "getIntersectionList":      1,
  "createSVGAngle":           1,
  "animationsPaused":         1,
  "setCurrentTime":           1,
  "deSelectAll":              1,
  
  // dialogs
  "print":                    1,
  "alert":                    1,
  "prompt":                   1,
  "confirm":                  1,
  "find":                     1,
  "deletemodule":             1,
  "addmodule":                1,
  
  // destructive
  "open":                     1,
  "write":                    1,
  "writeln":                  1,
  "location":                 1,
  "replace":                  1, // somehow this script keeps getting a hold of the "location" object. don't let it replace ;)
  "reload":                   1, // somehow this script keeps getting a hold of the "location" object.
  "assign":                   1, // somehow this script keeps getting a hold of the "location" object.
  "back":                     1, // history.back?
  "home":                     1, // history.home? navigator.home?
  "submit":                   1, // history.back?

  // Java
  "sun":                      1, // something to do with java. starts java and halts the script, at least when called with |new|.
  "java":                     1, // same
  "Packages":                 1, // same?

  // opener
  "opener":                   1, // might be a harness for this script - wouldn't want to screw with it
  
  // parts of this script, and things this script relies on
  "propertyBlacklist":        1, // hehe
  "knownObjects":             1,
  "reportError":              1,
  "randomJS":                 1,
  "rjscount":                 1,
  
  
  // things fuzz.js expects to be defined
  "fuzzSettings":             1,
  "fuzzCommands":             1,
  "fuzzerName":               1,
  "recordStrategy":           1,
  "initFuzzerSpecific":       1,
  "fuzzOnload":               1,
  "startFuzzing":             1,
  "makeCommand":              1,

  // parts of fuzz.js 
  "dumpEachCommand":          1,
  "dumpEachSeed":             1,
  "fuzzSeed":                 1,
  "numImmediate":             1,
  "stepsPerInterval":         1,
  "interval":                 1,
  "maxSteps":                 1,
  "recordMode":               1,
  "obtainSettings":           1,
  "initFuzzerGeneral":        1,
  "immedCount":               1,
  "immedChunk":               1,
  "immedStep":                1,
  "playFuns":                 1,
  "recordFuns":               1,
  "recordSomehow":            1,
  "playFunsChunk":            1,
  "randomizer":               1,
  "rnd":                      1,
  "rndElt":                   1,
  "dumpln":                   1,
  "simpleSource":             1,
  "giveToCopy":               1,
  "canQuitApplication":       1,
  "goQuitApplication":        1,
  "getURLParam":              1,
  "win":                      1,
  "doc":                      1,
  "pauseFuzzing":             1,
  "escPause":                 1,
  "gPageCompleted":           1, // ?
  "doCommand":                1,

  // Things this script relies on, and are best not screwed with.
  "setTimeout":               1,
  "dump":                     1,
  "status":                   1,
};
      
var randomArgs = [
  "undefined", 
  "null", 
  "true", 
  "false", 
  "'green'", 
  "'tuesday'", 
  "[]", 
  "{}", 
  "<foo/>",       // E4X
  "n1",
  "n1.length", 
  "n1.length-1", 
  "n1.__proto__",
  "n1.__parent__",
  "n1.prototype",
  "n1.constructor",
  "n1.call",
  "n1.apply",
  "n1.toSource()",
  "n1.toString()",
  "n1.toSource",
  "n1.toString",
  "('' + n1)",
  "uneval(n1)",
  "eval(n1)",
  "eval(n1, $)", // mozilla-specific -- sets up a scope for the eval
  "(n1 instanceof $)",
  "[n1]",
  "n1[$]",
  "(function(){})",

  // Tests for privilege escalation attacks.  Remember to keep strings quoted and free of SCRIPT tags.
  "(function(){alert(Components.classes)})", // Test for simple privilege escalation attacks.

// These three are commented out and replaced with simpler things to avoid triggering bug 341963
/*
  "\"location = 'javascript:alert(Components.classes);';\"", // This string was used in a "missing cx push" privilege escalation attack in bug 327126.
  "(function(){location = 'javascript:alert(Components.classes);';})", // Try combining the previous two items.
  "\"javascript:alert(Components.classes);\"", // javascript: URL used incorrectly.
*/
  "\"location = 'javascript:void 0;';\"", // This string was used in a "missing cx push" privilege escalation attack in bug 327126.
  "(function(){location = 'javascript:void 0;';})", // Try combining the previous two items.
  "\"javascript:void 0;\"", // javascript: URL used incorrectly.

  "\"data:text/html,<body onload='alert(Components.classes);'>\"", // data: URL used incorrectly.
  
  // Numbers!
  "0", 
  "1", 

  // Tests for integer overflow issues
  "0xffffffff",
  "0x10000000",
  "0x04000000",
  "0x01000000",
  
  // Tests for buffer overflow and array signedness issues
  "-1",
  "-4",
  "-10000000",
  "10000000",
  
  // Percents (as strings)
  "\"0%\"",
  "\"100%\"",
  "\"1000%\"",
  "\"-1%\"",
  
  // Special float values
  // "NaNs are unordered with respect to all IEEE doubles", which confuses code
  // that does "if out of range, clamp to be within range" rather than the other
  // way around or specifically looking for NaN values.
  "(3/0)",
  "(0/0)",
  "(-3/0)",
  
  
  // Tests for format string vulns
  "\"%s%s%s%s%s%s%s%s%s\"",
  "\"%n%n%n%n%n%n%n%n%n\"",
  
  // Embedded nulls and line breaks often confuse things
  // Hopefully I got the escaping right here!
  "\"\\0\"",
  "\"\\n\"",
  
  // The empty string: will cause a buffer overflow if code assumes it's not empty
  "\"\"",
  
  // Test box objects heavily
  "doc.getBoxObjectFor(n1)",
  
  // Curiousity
  "doc.createTextNode(n1)",
];


// javascript:for (i=0;i<hhh.length;++i){ try{ h = hhh[i]; dump(h + "\n"); dump("yay: " + (new h()) + "\n"); }catch(e){dump(e+"\n"); } } void 0
var constructors = [
    
  // http://lxr.mozilla.org/mozilla/source/extensions/xmlextras/build/src/nsXMLExtrasModule.cpp#147
  win.XMLSerializer,
  win.XMLHttpRequest,
  win.DOMParser,
  //XPointerResult,
  //XMLHttpProgressEvent,
  
  // JAVASCRIPT_GLOBAL_CONSTRUCTOR_CATEGORY and friends
  //InstallTrigger,
  win.SOAPCall,
  win.SOAPResponse,
  win.SOAPEncoding,
  win.SOAPFault,
  win.SOAPHeaderBlock,
  win.SOAPParameter,
  win.SOAPPropertyBagMutator,
  win.SchemaLoader,
  win.WSDLLoader,
  win.WebServiceProxyFactory,

  // HTML aliases that can actually be used
  win.Image,
  win.Option,

  // http://lxr.mozilla.org/seamonkey/source/js/src/xpconnect/src/xpcwrappednative.cpp#2941
  //win.Window,
  //win.HTMLDocument,
  //win.HTMLCollection,
  //win.Event,
  //win.ChromeWindow,

  // http://lxr.mozilla.org/seamonkey/source/dom/public/nsIDOMClassInfo.h#45 ... but many in this list don't work
  win.XSLTProcessor,
  win.XPathEvaluator,

  // JavaScript basics
  win.String,
  win.Object,
  win.Array,
  win.RegExp
];
  


function randomArgString()
{
  // Randomly pick an argument from randomArgs (static strings) *or* knownObjects (various things).
  
  if (rnd(3) != 0) {
    var j = rndElt(randomArgs);
    return j.replace(/\$/g, randomArgString);
  }
  else
    return "knownObjects[" + rnd(knownObjects.length) + "]";
}



randomJS.makeCommand = function()
{
  // Hackery
  if (immedCount == suggestedMaxSteps)
    randomJS.showObjects();

  if (randomJS.rv && randomJS.novel(randomJS.rv))
    return "'YAY!'; knownObjects[" + knownObjects.length + "] = randomJS.rv";
  else
    randomJS.rv = null;


  var n1index = rnd(knownObjects.length);
  
  var n1 = knownObjects[n1index];
  
  var p = randomProperty(n1);
  

  // Something to note about the test below: the randomness comes first in the 
  // short-circuited OR.  This is intended to prevent a small amount of nondeterminism
  // (different number of properties on a single object) from turning into absolute chaos
  // (random number generator offness).  

  // (What if I *want* nondeterminism to be obvious?  I could keep track of the sum 
  // of all the numbers passed to rndInt, and that would be even more effective.)

  // oldP allows Random JS to call functions that might not appear to
  // exist on certain objects.  (A bad example is "appendChild" on XML objects.)

  if (rnd(4) == 1 || propertyBlacklist[p]) 
    p = randomJS.oldP;
    
  randomJS.oldP = p;

  
  var s = "";

  // s += "rjscount=" + immedCount + "; ";
  
  s += "var n1 = knownObjects[" + n1index + "]; ";
  
  n1pString = "n1[" + simpleSource(p) + "]";


  switch(rnd(13)) {
  case 0: case 1: case 2:
    // Treat n1 or n1[p] as a function or constructor.
    
    if (rnd(2)) {
      itString = n1pString;
      try { it = n1[p]; } catch(e) { it = null; }
    } else {
      itString = "n1";
      it = n1;
    }
    
    s += "randomJS.rv = ";
    
    if (rnd(3) == 0)
      s += "new ";
      
    s += itString;
    
    // Guess the arity of the function, but try to be reasonable
    var guessedArity = 2;
    try { guessedArity = it.arity; /* same as .length */ } catch(er) { }

    if (rnd(3) == 0)
      guessedArity += rnd(10) - 2;

    if (rnd(3) == 0) {
      s += ".call"; // specify "this"
      guessedArity += 1; // we now need a "this" parameter too
    } 
      
    s += "(";
    if (guessedArity > 0)
      s += randomArgString();
    for (var w = 1; w < guessedArity; ++w)
      s += ", " + randomArgString();
    s += ");";
    
    break;

  case 3: case 4: case 5:
    s += "randomJS.rv = " + n1pString + ";"; break;
  case 6: case 7:
    s += n1pString + " = " + randomArgString() + ";"; break;
  case 8: 
    s += "delete " + n1pString; break;
  case 9:
    s += "n1.appendChild(" + randomArgString() + ");"; break;
  case 10:
    s += "n1.__defineGetter__(" + simpleSource(p) + ", " + randomArgString() + ");"; break;
  case 11:
    s += "n1.__defineSetter__(" + simpleSource(p) + ", " + randomArgString() + ");"; break;
  case 12:
    s += "randomJS.rv = n1.__lookupGetter__(" + simpleSource(p) + ");"; break;
  case 13:
    // This can lead to annoying chains in reduction.  But it does find bugs.
    // Note: this can trigger leaks (e.g. bug 329481), so turn it off for leak testing.
    // Commented out due to crash bug 358594.  Argh!
    // s += "n1.__proto__ = " + randomArgString() + ";"; break;
  }

  return s;
};


randomJS.novel = function(obj)
{
  if (!obj)
    return false;
    
  switch(typeof(obj)) {
    case "object":
    case "function":
      for (var i = 0; i < knownObjects.length; ++i)
        if (knownObjects[i] === obj)
          return false;
      return true;
    default:
      // number, string, boolean
      return false;
  }
}



function randomProperty(n)
{
  var p;
  // var props = [];
  var ct = 0, ix;
  
  try {

    // Avoid strangeness described in bug 369469 and comments there by skipping 
    // "focus" and "blur" items.
    // That is, don't call focus() and don't look at onfocus or onxblfocus events.
    // Hope order isn't affected :)
    
    for (p in n)
      if (!/focus/.test(p) && !/blur/.test(p))
        ++ct; // props.push(p);
        
    ix = rnd(ct);

    if (ct) { // (props.length)
      for (p in n)
        if (!/focus/.test(p) && !/blur/.test(p))
          if (ix-- == 0)
            return p;
    }
    else
      return rndElt(["foopy", "0", "1", "-1"]);

  }
  catch(e) {
    dumpln("WTF? Can't enumerate this thing!");
    dumpln(e);
    return "enumerationError";
  }
}





function resetNodeList() {
  anonymousCount = 0;
  var myRoot = doc.body || doc.documentElement; 
  allNodes = [];
  addDOMNodes(myRoot);
  knownObjects = allNodes;
  allNodes = null;
}


randomJS.init = function() { 

  resetNodeList(); // start with all the nodes in the document
  knownObjects.push(win);
  knownObjects.push(doc);
  knownObjects.push(doc.documentElement);
  knownObjects.push(doc.implementation); // to catch more bugs like 326646
  if (win.Components) {
    knownObjects.push(win.Components);
    knownObjects.push(win.Components.interfaces);
  }
  knownObjects.push(constructors); // don't push every item in here -- that would cause too much of the list to be constructors.


  try { er.ror } catch(er) { knownObjects.push(er); }
  knownObjects.push(/foo/ig);


//  knownObjects.push(<x/>); // commented out because this causes lots of issues (hangs, crashes, etc). these can be tested separately.

  //  knownObjects.push(eval(uneval(randomArgs))); // contains some things, like e4x, that are good to test properties of

//  knownObjects.push(Array.prototype.filter);
//  knownObjects.push(Array.prototype.forEach);
//  knownObjects.push(Array.prototype.every);
//  knownObjects.push(Array.prototype.map);
//  knownObjects.push(Array.prototype.some);
  
///  knownObjects.push(eval);
///  knownObjects.push(uneval);
  knownObjects.push( function(a,b){ return eval(a,b); } ); // this is basically eval, but with an fun.arity == 2. eval.arity==1 (because the second param is optional?).
  // e.g. javascript:alert(eval("body",doc))


  pruneRandomly(); // do more interesting things with fewer objects

  startFuzzing();
};



// Functions for debugging, reproducing, attacking nondeterminism, etc.

randomJS.countProps = function(obj)
{
  var c;
  for (var prop in obj)
    ++c;
  return c;
};


randomJS.testIteration = function()
{
  setTimeout(check, 200);
  
  for (iterI = 0; iterI < knownObjects.length; ++iterI)
    for (var p in knownObjects[iterI])
    {
      try {
        var j = knownObjects[iterI][p];
        j.arity;
        "" + j;
        uneval(j);
      } catch(e) { }
    }

  iterI = -1;
  
  function check()
  {
    if (iterI == -1)
      dumpln("Iteration works fine.");
    else
      dumpln("Iteration got stuck on knownObjects[" + iterI + "] !!!");
  }
}


randomJS.showObjects = function()
{
  for (var [i, obj] in knownObjects)
  {
    dumpln(i + ": " + typeof(obj) + " " + objToString(obj));
  }
  dumpln("That's all!");
  
  function objToString(o)
  {
    try {
      return "" + o
    } catch(e) {
      return "[" + e + "]"
    }
  }
}



randomJS.collectGarbage = function()
{
  try
  {
    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
  }
  catch(ex)
  {
    throw('collectGarbage: privilege failure ' + ex);
  }

  try
  {
    var JSD_CTRID = "@mozilla.org/js/jsd/debugger-service;1";
    var jsdIDebuggerService = Components.interfaces.jsdIDebuggerService;
    gJSDebuggerService = Components.classes[JSD_CTRID].
      getService(jsdIDebuggerService);
    gJSDebuggerService.GC();
    // alert("Happy");
  }
  catch(ex)
  {
    throw('colllectGarbage: other failure ' + ex);
  }
}


}
