// === Paste output from first run here, replacing the following two lines: ===

var fuzzSettings = null;
var fuzzCommands = null;

// === End pasteover ===


var fuzzerName = "Random Styles 3.1";
var recordStrategy = "Record without doing";
var suggestedMaxSteps = 5000;


var cssPairs = [
  {
    prop: "cssFloat", // not float, since that's a reserved keyword in javascript or the DOM Style spec or something like that
    values: ["left", "right", "none"]
  },
  {
    prop: "clear",
    values: ["none", "left", "right", "both"]
  },
  {
    prop: "display",
    values: ["inline", "block", "inline-block", "inline-table", "-moz-inline-block", "list-item", 
    "table", "table-row-group", "table-header-group", "table-footer-group", "table-row", "table-column-group",
    "table-column", "table-cell", "table-caption", "-moz-box", "-moz-inline-grid", "-moz-grid", "-moz-box", "-moz-inline-box",
    "-moz-grid-group", "-moz-grid-line", "-moz-stack", "-moz-inline-stack", "-moz-deck", "-moz-popup", "-moz-groupbox"]
  },
  {
    prop: "visibility",
    values: ["visible", "hidden", "collapse"]
  },
  {
    prop: "position",
    values: ["static", "relative", "absolute", "fixed"]
  },
  {
    prop: "overflow",
    values: ["visible", "scroll", "hidden", "auto"]
  },
  {
    prop: "color",
    values: ["red", "green", "blue", "black"]
  },
  {
    prop: "background",
    values: ["transparent", "#fcd", "url(http://www.google.com/images/logo_sm.gif)"]
  },
  {
    prop: "width",
    values: ["20em", "1px", "auto", "10%", "200%"]
  },
  {
    prop: "height",
    values: ["2em", "100px", "auto", "10%", "200%"]
  }
];


function makeCommand(mark) { 
  var n = rnd(allElements.length);
  var commandn = "allElements[" + n + "]";
  var cssPair = rndElt(cssPairs);
  var cssProp = cssPair.prop;
  var cssValue = rndElt(cssPair.values);
  var command = commandn + ".style." + cssProp + " = \"" + cssValue + "\"";
  return command;
}


var allElements=[];
var myRoot;

function addElements(n) {

  if (n.tagName && n.tagName.toLowerCase().indexOf("script" != -1) && n.getAttribute("id") && n.getAttribute("id").indexOf("fuzz") != -1) {
    if (n.previousSibling && n.previousSibling.nodeType == Node.TEXT_NODE)
      alert("Warning: fuzz script found with a whitespace node before it.  This could affect node counts.");
    return;
  }

  // XXX https://bugzilla.mozilla.org/show_bug.cgi?id=313078
  if (n.style)
    allElements.push(n);

  var i,c;
  for (i=0;c=n.childNodes[i];++i)
    if (c.nodeType == Node.ELEMENT_NODE)
      addElements(c);
}


function initFuzzerSpecific() { 
  var myRoot = doc.body || doc.documentElement; 
  addElements(myRoot);

  startFuzzing();
}
