// === Paste output from first run here, replacing the following two lines: ===

var fuzzSettings = null;
var fuzzCommands = null;

// === End pasteover ===


var fuzzerName = "Stir DOM 3.1";
var recordStrategy = "Record as it goes";
var suggestedMaxSteps = 20000;


var allNodes;
var myRoot;
var myRootParent;
var anonymousCount; // number of anonymous children (not descendents, just children)


function aC(q1, q2) { adopt(q1, q2); q1.appendChild(q2); }
function iB(q1, q2) { adopt(q1, q2); q1.parentNode.insertBefore(q2, q1); }
function rM(q1) { q1.parentNode.removeChild(q1); } // unused, but can be useful while narrowing testcases
// other things to try: clone instead of move, ...

function adopt(q1, q2)
{
  // ownerDocument can never be null, right?
  
  if (q1.ownerDocument != q2.ownerDocument)
  {
    q1.ownerDocument.adoptNode(q2); // this removes it from q2's document, right?
  }
  
  // at this point, it might make sense to assert that q1.ownerDocument == q2.ownerDocument
}

function makeCommand()
{
  var n1index = rnd(allNodes.length), n2index = rnd(allNodes.length);
  
  var n1 = allNodes[n1index];
  var n2 = allNodes[n2index];
  
  var commandn1 = "allNodes[" + n1index + "]";
  var commandn2 = "allNodes[" + n2index + "]";
  

  function isInDoc(n) {
    if (!n) 
      return false; 
    if (n.nodeType == Node.DOCUMENT_NODE)
      return true; 
    return isInDoc(n.parentNode); 
  }

  if (!isInDoc(myRoot)) {
    // Eep, there's probably nothing in the doc at all.  Make it less boring:
    return "myRootParent.appendChild(" + commandn1 + "); myRoot = " + commandn1 + ";";
  }
  
  // Move n2 in some way..
  
  if (n2 != myRoot || rnd(80) == 1) { // This fuzzer avoids moving the root node too often.

    if (rnd(80) == 1)
      // Don't do this too often -- it tends to make things less interesting.
      return "rM(" + commandn2 + ");";
    
    if (rnd(9) == 3)
      // Don't do this too often either -- it hurts reduction and it doesn't buy us much
      return "iB(" + commandn1 + ", " + commandn2 + ");";
      
    // Do this a lot ;)
    return "aC(" + commandn1 + ", " + commandn2 + ");";

  }
}




function resetNodeList() {
  allNodes=[];
  anonymousCount = 0;
  myRoot = doc.body || doc.documentElement; 
  myRootParent = myRoot.parentNode;
  addDOMNodes(myRoot, false, false, false);
}


function initFuzzerSpecific() { 
  resetNodeList();
  startFuzzing();
}

