// === Paste output from first run here, replacing the following two lines: ===

var fuzzSettings = null;
var fuzzCommands = null;

// === End pasteover ===


var fuzzerName = "SVG Element and Attribute fuzzer 3.1";
var recordStrategy = "Record as it goes";
var suggestedMaxSteps = 20000;


var allNodes;
var fuzzRoot;

var SVG_NS = "http://www.w3.org/2000/svg";


function aC(q1, q2) { q1.appendChild(q2); }
function iB(q1, q2) { q1.parentNode.insertBefore(q2, q1); }
function rM(q1) { q1.parentNode.removeChild(q1); } // unused, but can be useful while narrowing testcases
// other things to try: clone instead of move, ...


      
function makeSetAttribute(attrOrPair) {
  var attr;
  var value;
  
  if (typeof attrOrPair == "string") {
    attr = attrOrPair;
    value = randomThing(attributes[attr]);
  } else {
    attr = attrOrPair[0];
    value = randomThing(attrOrPair[1]);
  }

  if(rnd(5) == 1)
    value = randomThing(attributes[totallyRandomAttr()]); // note that this only looks in attributes, not new-style element-specific pairs
  
  // if(rnd(10) == 1)
  //   return "['" + attr + "'] = " + simpleSource(value) + ";";

  if (attr == "xlink:href")
    return ".setAttributeNS('http://www.w3.org/1999/xlink', 'xlink:href', " + simpleSource(value) + "); ";
  else
    return ".setAttribute('" + attr + "', " + simpleSource(value) + "); ";
}
      
      
function makeCommand()
{
  var n1index = rnd(allNodes.length), n2index = rnd(allNodes.length);
  
  var n1 = allNodes[n1index];
  var n2 = allNodes[n2index];
  
  var commandn1 = "allNodes[" + n1index + "]";
  var commandn2 = "allNodes[" + n2index + "]";
  var command;
  
  while(1){
  switch (rnd(9)) {
  case 0:
  case 1:
  case 2:
  
    // Change an attribute on n1, based on n1's tagName.
    
    if (!n1.tagName)
      break;
      
    var attrs = rnd(2) ? elements[n1.tagName] : commonAttributes;
    var attr = attrs ? rndElt[attrs] : null;
    if (!attr || rnd(5) == 1) {
      attr = totallyRandomAttr();
      // dumpln("*** " + attr);
    }

    return commandn1 + makeSetAttribute(attr);

  case 3:
    // Remove an attribute on n1, based on n1's current attribute list.
    
    var attrs = n1.attributes;
    if (attrs && attrs.length) {
      var attr = rndElt(attrs).name;
      return commandn1 + ".removeAttribute('" + attr + "');";
    }
    
    break;
    
  case 4:
    // Create a new element!
    // Set some attributes on it?  Nah.
    // Place it randomly, but only rarely place it outside of the document, because that's usually boring.
    
    // var commonElementList = ["linearGradient", "stop", "rect"]
    // var tag = rndElt(rnd(2) ? elementList : commonElementList);
    var tag = rndElt(elementList);
    var newIndex = allNodes.length;
    

    var createness = "var ne = document.createElementNS(SVG_NS, '" + tag + "'); allNodes[" + newIndex + "] = ne; ";
    
    if (rnd(3) > 0) {
      // Set most of this thing's attributes.
      // Do common attributes first, so element-specific lists of IDs (etc.) override.

      attrlist = commonAttributes;
      for (i=0;attr=attrlist[i];++i) {
        if (rnd(10) != 1) {
          createness += "ne" + makeSetAttribute(attr);
        }
      }

      attrlist = elements[tag];
      for (i=0;attr=attrlist[i];++i) {
        if (rnd(10) != 1) {
          createness += "ne" + makeSetAttribute(attr);
        }
      }
    }
    
    if (tag == "text" || tag == "tspan" || tag == "textPath") {
      if (rnd(5) != 1)
        createness += "ne.appendChild(document.createTextNode(" + simpleSource(rndElt(texts)) + "));";
    }
      
    
    function isInDoc(n) { if (!n) return false; if (n.nodeType == Node.DOCUMENT_NODE) return true; return isInDoc(n.parentNode); }

    if (isInDoc(n1) != (rnd(10) == 1))
      return createness + commandn1 + ".appendChild(ne); ";
    else
      return createness + "fuzzRoot.appendChild(ne); ";

    break;

  case 5:
  case 6:
  case 7:
    // Move n2 in some way..
    
    if(n2index > 1) { // This fuzzer avoids screwing with the root node.
  
      if (rnd(20) == 1)
        // Don't do this too often -- it tends to make things less interesting.
        return "rM(" + commandn2 + ");";
      
      if (rnd(9) == 3)
        // Don't do this too often either -- it hurts reduction and it doesn't buy us much
        return "iB(" + commandn1 + ", " + commandn2 + ");";
        
      // Do this a lot ;)
      return "aC(" + commandn1 + ", " + commandn2 + ");";
    }
    
    break;
    
  case 8:
    // Add some text -- this is partly for visual effect rather than finding more bugs.
  
    return "aC(" + commandn1 + ", allNodes[" + allNodes.length + "] = document.createTextNode('<" + n1.tagName + ">'));";
  
  }
  }
  
}


function resetNodeList() {
  allNodes = [];
  fuzzRoot = doc.body || doc.documentElement;
  addDOMNodes(fuzzRoot);
}


function initFuzzerSpecific() { 
  resetNodeList();
  startFuzzing();
}



function randomThing(obj)
{
  if (obj == null)
    return null;
    
  if (typeof obj == "function")
    return obj();
    
  if (typeof obj == "string")
    return obj; // not to be treated as an array :)

  if (obj.length) { // non-empty array
    var x = rndElt(obj);
    //dumpln(x);
    return randomThing(x)
  }

  if (obj.length === 0)
    return null;

  // Otherwise, it should be a number, etc.
  return obj;
}



var names =    [  "a",  "b",  "c",  "d",  "e",  "f",  "g",  "1" ];
var chars = names;
var namerefs = [ "#a", "#b", "#c", "#d", "#e", "#f", "#g", "#1" ];


// http://www.w3.org/TR/SVG/struct.html#Head gives a list of things that reference and can be referenced :)
var gradientIDs = function() { return "grad" + rnd(3); };
var patternIDs = function() { return "pat" + rnd(3); };
var pserverIDs = [gradientIDs, patternIDs];
var gradientRefs = function() { return "url(#" + randomThing(gradientIDs) + ")"; };
var patternRefs = function() { return "url(#" + randomThing(patternIDs) + ")"; };
var pserverRefs = function() { return "url(#" + randomThing(pserverIDs) + ")"; };

var symbolIDs = function() { return "symb" + rnd(3); };
var symbolRefs = function() { return "url(#" + randomThing(symbolIDs) + ")"; };

var textIDs = function() { return "text" + rnd(5); };
var textRefs = function() { return "url(#" + randomThing(textIDs) + ")"; };

var pathIDs = function() { return "path" + rnd(5); };
var pathRefs = function() { return "url(#" + randomThing(pathIDs) + ")"; };

var markerIDs = ["marker6", function() { return "marker" + rnd(5); }];
var markerRefs = function() { return "url(#" + randomThing(markerIDs) + ")"; };



var anythingRefs = function() { return "url(#" + randomThing([symbolIDs, textIDs, pathIDs, names]) + ")"; };


var charsets = [ "UTF-8", "ISO-8859-1" ];
var URIs = [
  ["http://www.squarefree.com/", "http://www.squarefree.com/feed"], 
  ["#a", "#b"], 
  "data:text/html,", 
  ["javascript:alert(Components.classes)", "javascript:5555", "javascript:'QQQQ' + String.fromCharCode(0) + 'UUUU'"], 
  "http://www.mozilla.org/status/tree.gif"
  ];
  
  // gopher://seanm.ca/
  
var numbers = [-2, -1, 0, "-0", "+0", 0.5, 1, "+1", 2, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100, 1000];
var lengths = [.1, 1, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100, 1000, "20%", "50%", "80%", "100%"]; 
var smallLengths = [1, 2, 3, 4, 5, 6, 7, 8, 9, lengths];
function numbersWithUnits() { return rndElt(numbers) + rndElt(["px", "em", "pt", "%", ""]) }
var relations = ["alternate"];
var mimeTypes = ["text/html", "text/plain", "text/css", "text/javascript", "application/rss+xml"];
var texts = ["", "foo", "bar", "baz", "zap", "Abbey\nRoad", 'QQQQ' + String.fromCharCode(0) + 'UUUU', "gazebo", "firefox", "The quick brown fox jumps over the lazy dog."];
var colors = ["lime", "red", "blue", "#CCC", "#777777"];
var percents = ["0%", "-10%", "20%", "30%", "50%", "80%", "99.999%", "100%", "120%"];
var opacities = ["0", ".2", ".3", ".5", ".8", "1"];
var scriptcode = [// "alert('script')", 
  "var t = event.originalTarget; if(t) { dumpln('script 1 called! ' + t.tagName + ' ' + event.type); t.parentNode.removeChild(t); }",
  "var t = event.originalTarget; if(t) { dumpln('script 2 called! ' + t.tagName + ' ' + event.type); var p = t.parentNode; p.parentNode.removeChild(p); }"
  //"window.close()"
  ];
var booleans = ["true", "false"];
var angles = ["0deg", "30deg", "45deg", "60deg", "1rad", "90deg", "180deg", "270deg", "360deg"];
var transforms = [["translate(20,2.5)", "rotate(10)", "skewY(30)", "skewX(30)", "scale(3)", "scale(.2)"], ""];
var paints = ["grad1", "grad2", [["none", "inherit", "currentColor"], colors], pserverRefs];

function longThing()
{
  // a string of all A's in a buffer overflow has the nice property
  // of a guaranteed crash on some architectures, IIRC
  
  var x = "A"; 
  for (var i = 0; i < 14; ++i)
    x = x + x;
  return x; 
}


var commonAttributes = ["id", "name", "color", "opacity", "fill", "fill-rule", "fill-opacity", "stroke", "stroke-width", "stroke-linecap", "stroke-linjoin", "stroke-miterlimit", "stroke-dasharray", "stroke-dashoffset", "stroke-opacity", "transform", "display", "visibility"];


var attributes = {
"randomcrap": ["", "\0", longThing],

// http://www.w3.org/TR/SVG11/types.html

"id": names,
"name": names,
"color": colors,
"opacity": opacities,

"fill": paints,
"fill-rule": ["nonzero", "evenodd"],
"fill-opacity": opacities,

"stroke": paints,
"stroke-width": smallLengths,

"stroke-linecap": ["butt", "round", "square"],
"stroke-linejoin": ["miter", "round", "bevel"],
"stroke-miterlimit": [4, 1, 9],

"stroke-dasharray": ["none", "5,3,2", "3,3"],
"stroke-dashoffset": [0, 1, 4],
"stroke-opacity": opacities,

"display": ["none", "inline", "block", "inline-block"], // wtf
"visibility": ["visible", "hidden", "collapse"], // wtf

"x": lengths,
"y": lengths,
"width": lengths,
"height": lengths,
"rx": lengths,
"ry": lengths,
"cx": lengths,
"cy": lengths,
"rx": lengths,
"ry": lengths,
"x1": lengths,
"x2": lengths,
"y1": lengths,
"y2": lengths,
"viewBox": "0 0 30 40",
"preserveAspectRatio": ["xMaxYMax meet", "xMidYMid slice", "xMidYMid meet"],
"zoomAndPan": ["disable", "magnify"],
"xlink:href": anythingRefs,
"transform": transforms,
"requiredFeatures": ["", "", "", "", ""],
"requiredExtensions": ["", "", "", "http://example.com/SVGExtensions/EmbeddedXHTML", "foopy"],
"overflow": ["visible", "hidden", "scroll", "auto", "inherit"],
"d": [
  "M100,200 C100,100 250,100 250,200 S400,300 400,200",
  "M600,350 l 50,-25 a25,25 -30 0,1 50,-25 l 50,-25 a25,50 -30 0,1 50,-25 l 50,-25 a25,75 -30 0,1 50,-25 l 50,-25 a25,100 -30 0,1 50,-25 l 50,-25"
],
"points": [
  "50,375 150,375 150,325 250,325 250,375 350,375 350,250 450,250 450,375 550,375 550,175 650,175 650,375 750,375 750,100 850,100 850,375 950,375 950,25 1050,25 1050,375 1150,375", // rectangles
  "350,75  379,161 469,161 397,215 423,301 350,250 277,301 303,215 231,161 321,161" // star
],
"dx": [0],
"dy": [0],
"rotate": ["0", "0 10 20 30 40 50 60 70 80"],
"lengthAdjust": ["spacing", "spacing", "spacing", "spacingAndGlyphs"],
"writing-mode": ["lr-tb", "lr", "rl-tb", "rl", "tb-rl", "tb"],
"direction": ["ltr", "rtl"],
"unicode-bidi": ["normal", "embed", "bidi-override", "inherit"],
"text-anchor": ["start", "middle", "end"],
"dominant-baseline": ["auto", ["use-script", "no-change", "reset-size", "ideographic", "alphabetic", "hanging", "mathematical", "central", "middle", "text-after-edge", "text-before-edge", "inherit"]],
"alignment-baseline": ["auto", ["baseline", "before-edge", "text-before-edge", "middle", "central", "after-edge", "text-after-edge", "ideographic", "alphabetic", "hanging", "mathematical", "inherit"]],
"baseline-shift": ["baseline", ["sub", "super", percents, lengths, "inherit"]],
"kerning": ["auto", smallLengths],
"letter-spacing": ["auto", smallLengths],
"word-spacing": ["auto", smallLengths],
"text-decoration": ["none", ["underline", "overline", "line-through", "blink"]],

"marker-start": ["", markerRefs],
"marker-end": ["", markerRefs],
"marker-mid": ["", markerRefs],
"marker": ["", markerRefs],


// marker
"markerUnits": ["strokeWidth", "userSpaceOnUse"],
"markerWidth": lengths,
"markerHeight": lengths,
"orient": ["auto", angles],

// gradient
"gradientUnits": ["userSpaceOnUse", "objectBoundingBox"],
"gradientTransform": transforms,
"spreadMethod": ["pad", "reflect", "repeat"],

// radialGradient
"r": lengths,
"fx": ["", lengths],
"fy": ["", lengths],

// stop
"offset": lengths, // :(
"stop-color": colors,
"stop-opacity": opacities,

// pattern
"patternUnits": ["userSpaceOnUse", "objectBoundingBox"],
"patternContentUnits": ["userSpaceOnUse", "objectBoundingBox"],
"patternTransform": transforms



};



// "foo" means look it up in the attributes array to find a value.
// ["foo", bar] means use bar to find a value.  (used on very overloaded attributes, such as "id")

var elements = 
{
// http://www.w3.org/TR/SVG11/shapes.html
"rect": ["x", "y", "width", "height", "rx", "ry"],
"circle": ["cx", "cy", "rx", "ry"],
"ellipse": ["cx", "cy", "rx", "ry"],

"g": [],
"svg": ["x", "y", "width", "height", "viewBox", "preserveAspectRatio", "zoomAndPan"], // "Another use for 'svg' elements within the middle of SVG content is to establish a new viewport." -- http://www.w3.org/TR/SVG/struct.html]

"symbol": ["viewbox", ["id", symbolIDs] ],
"use": ["x", "y", "width", "height", ["xlink:href", [anythingRefs, symbolRefs]], "transform"],
// "image": ["x", "y", "width", "height", ["xlink:href", "http://www.mozilla.org/status/tree.gif"]], // avoid hitting bug 295639
"switch": [],
"line": ["x1", "x2", "x3", "x4", "marker-start", "marker-mid", "marker-end", "marker"],
"path": ["d", ["id", pathIDs], "marker-start", "marker-mid", "marker-end", "marker"],
"polyline": ["points", "marker-start", "marker-mid", "marker-end", "marker"],
"polygon": ["points", "marker-start", "marker-mid", "marker-end", "marker"],

// all text stuff WAS commented out, too many assertions
"text": ["x", "y", "dx", "dy", "rotate", /* "textLength", */ "lengthAdjust", ["id", textIDs], "writing-mode"],
"tspan": ["x", "y", "dx", "dy", "rotate", /* "textLength", */ "lengthAdjust", ["id", textIDs]],
"tref": ["x", "y", "dx", "dy", "rotate", ["xlink:href", textRefs]],
"textPath": [["xlink:href", pathRefs]],

"marker": ["markerUnits", "markerWidth", "markerHeight", "orient", ["id", markerIDs]], // also refX and refY, skipping

"linearGradient": ["gradientUnits", "gradientTransform", "x1", "y1", "x2", "y2", "spreadMethod", ["id", gradientIDs], ["xlink:href", gradientRefs]],
"radialGradient": ["gradientUnits", "gradientTransform", "cx", "cy", "r", "fx", "fy", "spreadMethod", ["id", gradientIDs], ["xlink:href", gradientRefs]],
"stop": ["offset", "stop-color", "stop-opacity"],

"pattern": ["patternUnits", "patternContentUnits", "patternTransform", "x", "y", "width", "height", ["id", patternIDs], ["xlink:href", patternRefs]],

"foreignObject": ["x", "y", "width", "height", "requiredExtensions"]

// clipPath?
// filters?
// animation?
};




// attributes is a hash, but sometimes we want to treat it as an array-like thing.  so....
attributeList = [];
for (var prop in attributes)
  attributeList.push(prop);

function totallyRandomAttr() { 
  // Emphasize basic stuff. 
  if (rnd(3)==1) 
    return rndElt(["id", "name"]);
  return rndElt(attributeList); 
}
// attributes is a hash, but sometimes we want to treat it as an array-like thing.  so....
elementList = [];
for (var prop in elements)
  elementList.push(prop);

