// === Paste output from first run here, replacing the following two lines: ===

var fuzzSettings = null;
var fuzzCommands = null;

// === End pasteover ===


var fuzzerName = "XUL Element and Attribute fuzzer 3.1";
var recordStrategy = "Record as it goes";
var suggestedMaxSteps = 10000;


var allNodes;
var fuzzRoot;

var XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";


function aC(q1, q2) { q1.appendChild(q2); }
function iB(q1, q2) { q1.parentNode.insertBefore(q2, q1); }
function rM(q1) { q1.parentNode.removeChild(q1); } // unused, but can be useful while narrowing testcases
// other things to try: clone instead of move, ...

function makeCommand()
{
  var n1index = rnd(allNodes.length), n2index = rnd(allNodes.length);
  
  var n1 = allNodes[n1index];
  var n2 = allNodes[n2index];
  
  var commandn1 = "allNodes[" + n1index + "]";
  var commandn2 = "allNodes[" + n2index + "]";
  var command;
  
  while(1){
  switch (rnd(9)) {
  case 0:
  case 1:
  case 2:
  
    // Change an attribute on n1, based on n1's tagName.
    
    if (!n1.tagName)
      break;
      
    var attrs = rnd(2) ? elements[n1.tagName] : commonAttributes;
    var attr = attrs ? rndElt[attrs] : null;
    if (!attr || rnd(5) == 1) {
      attr = totallyRandomAttr();
      // dumpln("*** " + attr);
    }
      
    var value = randomThing(rnd(5) == 1 ? attributes[totallyRandomAttr()] : attributes[attr]);
    
    if (attr) {
      if (rnd(2))
        // Set it as a property.
        return commandn1 + "['" + attr + "'] = " + simpleSource(value) + ";";
      else 
        // Set it as an attribute.
        return commandn1 + ".setAttribute('" + attr + "', " + simpleSource(value) + ");";
    }
      
    break;
    
  case 3:
    // Remove an attribute on n1, based on n1's current attribute list.
    
    var attrs = n1.attributes;
    if (attrs && attrs.length) {
      var attr = rndElt(attrs).name;
      return commandn1 + ".removeAttribute('" + attr + "');";
    }
    
    break;
    
  case 4:
    // Create a new element!
    // Set some attributes on it?  Nah.
    // Place it randomly, but only rarely place it outside of the document, because that's usually boring.
    
    var tag = rndElt(elementList);
    var newIndex = allNodes.length;
    

    var createness = "var ne = document.createElementNS(XUL_NS, '" + tag + "'); allNodes[" + newIndex + "] = ne; ";
    
    function isInDoc(n) { if (!n) return false; if (n.nodeType == Node.DOCUMENT_NODE) return true; return isInDoc(n.parentNode); }

    if (isInDoc(n1) != (rnd(10) == 1))
      return createness + commandn1 + ".appendChild(ne); ";
    else
      return createness + "fuzzRoot.appendChild(ne); ";

    break;

  case 5:
  case 6:
  case 7:
    // Move n2 in some way..
    
    if(n2index > 1) { // This fuzzer avoids screwing with the root node.
  
      if (rnd(20) == 1)
        // Don't do this too often -- it tends to make things less interesting.
        return "rM(" + commandn2 + ");";
      
      if (rnd(9) == 3)
        // Don't do this too often either -- it hurts reduction and it doesn't buy us much
        return "iB(" + commandn1 + ", " + commandn2 + ");";
        
      // Do this a lot ;)
      return "aC(" + commandn1 + ", " + commandn2 + ");";
    }
    
    break;
    
  case 8:
    // Add some text -- this is partly for visual effect rather than finding more bugs.
  
    switch(rnd(3)) {
    case 0:
      return "aC(" + commandn1 + ", allNodes[" + allNodes.length + "] = document.createTextNode('<" + n1.tagName + ">'));";
    case 1:
      return commandn1 + ".setAttribute('value', '`" + n1.tagName + "`');";
    case 2:
      return commandn1 + ".setAttribute('label', '/" + n1.tagName + "/');";
    }
  
  }
  }
  
}


function resetNodeList() {
  allNodes = [];
  fuzzRoot = doc.body || doc.documentElement;
  addDOMNodes(fuzzRoot, false, false, false);
}


function initFuzzerSpecific() { 
  resetNodeList();
  startFuzzing();
}



function randomThing(obj)
{
  if (obj == null)
    return null;
    
  if (typeof obj == "function")
    return obj();
    
  if (typeof obj == "string")
    return obj; // not to be treated as an array :)

  if (obj.length) { // non-empty array
    var x = rndElt(obj);
    //dumpln(x);
    return randomThing(x)
  }

  if (obj.length === 0)
    return null;

  // Otherwise, it should be a number, etc.
  return obj;
}



var names =    [  "a",  "b",  "c",  "d",  "e",  "f",  "g",  "1" ];
var chars = names;
var namerefs = [ "#a", "#b", "#c", "#d", "#e", "#f", "#g", "#1" ];
var charsets = [ "UTF-8", "ISO-8859-1" ];
var URIs = [
  ["http://www.squarefree.com/", "http://www.squarefree.com/feed"], 
  ["#a", "#b"], 
  "data:text/html,", 
  ["javascript:alert(Components.classes)", "javascript:5555", "javascript:'QQQQ' + String.fromCharCode(0) + 'UUUU'"], 
  "http://www.mozilla.org/status/tree.gif"
  ];
  
  // gopher://seanm.ca/
  
var numbers = [-2, -1, 0, "-0", "+0", 0.5, 1, "+1", 2, 3, 4, 5, 6, 7, 8, 100];
function numbersWithUnits() { return rndElt(numbers) + rndElt(["px", "em", "pt", "%", ""]) }
var relations = ["alternate"];
var mimeTypes = ["text/html", "text/plain", "text/css", "text/javascript", "application/rss+xml"];
var texts = ["", "foo", "bar", "baz", "zap", 
  // These cause problems when trying to reduce, because simpleSource doesn't handle
  // line breaks and nulls :(
  //"Abbey\nRoad", 'QQQQ' + String.fromCharCode(0) + 'UUUU'
];
var colors = ["lime", "red", "blue", "#CCC", "#777777"];
var percents = ["0%", "-10%", "50%", "80%", "99.999%", "100%", "120%"];
var scriptcode = [// "alert('script')", 
  ""
// Neutered to avoid hitting bug 353610
//  "var t = event.originalTarget; if(t) { dumpln('script 1 called! ' + t.tagName + ' ' + event.type); t.parentNode.removeChild(t); }",
//  "var t = event.originalTarget; if(t) { dumpln('script 2 called! ' + t.tagName + ' ' + event.type); var p = t.parentNode; p.parentNode.removeChild(p); }"
// Ideas for things to add
//  "throw 1"
//  "document.removeChild(document.documentElement);" // and put it back later?
  //"window.close()"
  ];
var booleans = ["true", "false"];

function longThing()
{
  // a string of all A's in a buffer overflow has the nice property
  // of a guaranteed crash on some architectures, IIRC
  
  var x = "A"; 
  for (var i = 0; i < 14; ++i)
    x = x + x;
  return x; 
}


// http://xulplanet.com/references/elemref/ref_XULElement.html#attr_align
var commonAttributes = ["align", "allowevents", "allownegativeassertions", "class", "coalesceduplicatearcs", 
"collapsed", "container", "containment", "context", "contextmenu",
"datasources", "dir", "empty", "equalsize", "flags",
"flex", "height", "hidden", "id", "insertafter",
"insertbefore", "left", "maxheight", "maxwidth", "menu",
"minheight", "minwidth", "mousethrough", "observes", "ordinal", 
"orient", "pack", "persist", "popup", "position",
"preference-editable", "ref", "removeelement", "sortDirection", "sortResource",
"sortResource2", "statustext", "style", "template", "tooltip",
"tooltiptext",  "top", "uri", "wait-cursor", "width"];


var attributes = {
"randomcrap": ["", "\0", longThing],


// From http://www.xulplanet.com/references/elemref/ref_XULElement.html
// Quite a few of these only apply to overlays, or to RDF-generated stuff.

"id": names,
"name": names,
"align": ["start", "center", "end", "baseline", "stretch", "left", "right"],
"allowevents": booleans,
"allownegativeassertions": booleans,
"class": names,
"coalesceduplicatearcs": booleans,
"collapsed": booleans,
"container": booleans,
"containment": URIs, // Type: URI of an RDF predicate
"context": names, // Type: popup element id.
"contextmenu": names,
"datasources": URIs, // Actually multiple URIs
"dir": [
  ["normal", "reverse"], // most elements
  ["left", "right", "top", "bottom", "bottomleft", "bottomright", "topleft", "topright"] // resizer
  ],
"empty": booleans,
"equalsize": ["always", "never"],
"flags": [
  ["dont-test-empty", "dont-build-content", "dont-test-empty dont-build-content"], // all elements
  "dont-build-content" // tree
  ],
"flex": numbers,
"height": numbers,
"hidden": booleans,
"id": names,
"insertafter": names,
"insertbefore": names,
"left": numbers,
"maxheight": numbers,
"maxwidth": numbers,
"menu": names, // Type: popup element id
"minheight": numbers,
"minwidth": numbers,
"mousethrough": ["always", "never"],
"observes": names, // Type: broadcaster element id
"ordinal": numbers,
"orient": ["horizontal", "vertical"],
"pack": ["start", "center", "end"],
// "persist": ??, // Type: space separated list of attribute names
"popup": names, // Type: popup element id
"position": numbers, // index into a child list
"preference-editable": booleans,
"ref": URIs, // Type: URI of an RDF resource
"removeelement": names,
"sortDirection": ["ascending", "descending", "natural"],
"sortResource": URIs,
"sortResource2": URIs,
"statustext": texts,
// "style": ??
"template": names, // ??

"tooltip": names,
"tooltiptext": texts,

"top": numbers, // for elements in a stack??
"uri": ["rdf:*", URIs], // ? (special meaning for <xul:content>)
"wait-cursor": booleans, // ?
"width": numbers,

// overloaded

"type": [
  "content", "content-primary", // browser
  "button", // colorpicker
  "checkbox", // listitem, menuitem
  "radio", // menuitem
  ["bool", "int", "string", "unichar", "wstring", "file"], // preference
  ["autocomplete", "password", "timed"], // textbox
  ["menu", "menu-button"], // toolbarbutton  
  ["checkbox", "progressmeter", "text"], // treecol
  ],

// <xul:browser>
"autocompleteenabled": booleans,
"autocompletepopup": names,
"autoscroll": booleans,
"disablehistory": booleans,
"disablesecurity": booleans,
"homepage": URIs,
"src": URIs,

// checkbox
"accesskey": chars,
"checked": booleans,
"command": names,
"crop": ["start", "end", "left", "right", "center", "none"],
"disabled": booleans,
"image": URIs,
"label": texts,
"preference": names,
"tabindex": numbers,

// colorpicker
"color": colors,

// commandset
"commandupdater": booleans,
"events": ["focus", "select", "clipboard", "undo", "*"],
"oncommandupdate": scriptcode,
"targets": names, // really multiple names

// command
"oncommand": scriptcode,

// content
"tag": ["treechildren", "content"], // ?

// deck
"selectedIndex": numbers,

// description
"control": names,
"value": [texts, percents], // percents for progressmeter

// dialogheader
"title": texts,
"description": texts,

// editor
"editortype": ["html", "text"],

// image
"onerror": scriptcode,
"onload": scriptcode,
"src": URIs,
"validate": ["always", "never"], // also menuitem

// key
"key": [chars, names], // chars in <xul:key>, names in e.g. <xul:menu> referencing a <xul:key>.
"keycode": ["VK_RETURN", "VK_ENTER", "VK_I"],
"modifiers": ["shift", "alt", "meta", "control", "accel", "accel,shift"],

// listbox
"disableKeyNavigation": booleans,
"rows": numbers,
"seltype": ["single", "multiple"],
"suppressonselect": booleans,
"onselect": scriptcode,

// listitem
"current": booleans,

// menu
"acceltext": [chars, texts],
"allowevents": booleans,
"menuactive": booleans,
"open": booleans,
"sizetopopup": ["none", "always"], // not never/always!? according to http://xulplanet.com/references/elemref/ref_menu.html

// menubar
"grippyhidden": booleans,
"statusbar": names,

// menuitem
"autocheck": booleans,

// menulist
"readonly": booleans,
"focused": booleans, // !!
"disableautoselect": booleans,
"editable": booleans,

// menupopup
"ignorekeys": booleans,
"top": numbers,
"left": numbers,
"onpopuphidden": scriptcode,
"onpopuphiding": scriptcode,
"onpopupshowing": scriptcode,
"onpopupshown": scriptcode,
"position": ["after_start", "after_end", "before_start", "before_end", "end_after", "end_before", "start_after", "start_before", "overlap", "at_pointer", "after_pointer"],

// observes
"attribute": ["*", "attribute", "", "disabled"],
"element": names,

// preference
"inverted": booleans,
"instantApply": booleans,

// prefpane
"helpURI": URIs,
"onpaneload": scriptcode,


"mode": [
  ["determined", "undetermined"], // progressmeter
  ["none", "normal", "undetermined"] // treecell
  ],

// scrollbar
"curpos": numbers, 
"increment": numbers, 
"maxpos": numbers, 
"pageincrement": numbers,

// splitter
"collapse": ["none", "before", "after"],
"resizeafter": ["closest", "farthest", "grow"],
"resizebefore": ["closest", "farthest"],
"state": ["open", "collapsed", "dragging"],

// tab
"afterselected": booleans,
"beforeselected": booleans,
"linkedpanel": names,

// tabbrowser
"autoscroll": booleans,
"contentcontextmenu": names,
"contenttooltip": names,
"handleCtrlPageUpDown": booleans,
"onbookmarkgroup": scriptcode,
"onnewtab": scriptcode,

// tabbox
"handleCtrlTab": booleans,
"eventnode": ["parent", "window", "document"],

// tabs
"closebutton": booleans,
"disableclose": booleans,
"first-tab": booleans,
"last-tab": booleans,
"onclosetab": scriptcode,
"onnewtab": scriptcode,
"onselect": scriptcode,
"setfocus": booleans,
"tooltiptextnew": texts,

// textbox
"cols": numbers,
"maxlength": numbers,
"multiline": booleans,
"onchange": scriptcode,
"oninput": scriptcode,
"timeout": numbers,
"wrap": ["off"],

// toolbar
"currentset": names, // :(
"customindex": numbers,
"customizable": booleans,
"defaultset": names,
"grippyhidden": booleans,
"grippytooltiptext": texts,
"toolbarname": texts,

// toolbarbutton
"autoCheck": booleans,
"checkState": [0,1,2],
"dlgType": ["accept", "cancel", "help", "disclosure"],
"group": names, // ?

// tooltip
"default": booleans,
"noautohide": booleans,

// tree
"enableColumnDrag": booleans,
"hidecolumnpicker": booleans,
"statedatasource": URIs,

// treechildren
"alternatingbackground": booleans,

// treecol
"cycler": booleans,
"dragging": booleans,
"fixed": booleans,
"hidden": booleans,
"hideheader": booleans,
"ignoreincolumnpicker": booleans,
"primary": booleans,
"sortActive": booleans,

// treeitem
"open": booleans,

// window
"hidechrome": booleans,
"screenX": numbers,
"screenY": numbers,
"sizemode": ["maximized", "minimized", "normal"],
"windowtype": names,

// causing trouble?
//"onmousemove": scriptcode,


};




var elements = 
{
"action": [],
// "arrowscrollbox": ["orient"], // bug 360761
"bbox": [],
"binding": ["object", "predicate", "subject"],
"bindings": [],
"box": [],
"broadcaster": ["id"],
"broadcasterset": [],
"button": ["label"],
// "browser": ["autocompleteenabled", "autocompletepopup", "autoscroll", "disablehistory", "disablesecurity", "homepage", "src", "type"],
  // browser sounds dangerous ;)
  // and indeed it is. commented out to avoid hitting bug 344211.
  
"checkbox": ["accesskey", "checked", "command", "crop", "disabled", "image", "label", "preference", "tabindex"],
"caption": ["accesskey", "crop", "image", "label", "tabindex"],
"colorpicker": ["color", "preference", "tabindex", "type"],
"column": [],
"columns": [],
"commandset": ["commandupdater", "events", "oncommandupdate", "targets"],
"command": ["oncommand"],
"conditions": [],
"content": ["tag", "uri"],
"deck": ["selectedIndex"],
"description": ["accesskey", "control", "crop", "disabled", "value"],
"dialog": [], // has tons of attributes; skipping them.
"dialogheader": ["crop", "description", "title"],

// editor seems to cause the same problems as iframes (bug 344216)
// "editor": ["editortype", "src", "type"],

"grid": [],
"grippy": [],
"groupbox": [],
"hbox": [],

// iframe commented out to avoid triggering bug 344216 and maybe speed things up.
// "iframe": ["src"],


"image": ["onerror", "onload", "src", "validate"],
"key": ["command", "disabled", "key", "keycode",  "keytext", "modifiers", "oncommand", "phase"],
"keyset": [],
"label": ["accesskey", "control", "crop", "disabled", "value"],
// listboxes used to be crashy. wonder if they still are
"listbox": ["disableKeyNavigation", "disabled", "preference", "rows", "seltype", "suppressonselect", "tabindex", "value"],
// "listcell": ["crop", "disabled", "image", "label", "type"], // bug 360761
"listcol": [],
"listcols": [],
"listhead": [],
"listheader": ["disabled"],
"listitem": ["accesskey", "checked", "command", "crop", "current", "disabled", "image", "label", "preference", "selected", "tabindex", "type", "value"],
"member": ["child", "container"], // advanced rdf rules stuff
"menu": ["acceltext", "accesskey", "allowevents", "crop", "disabled", "key", "label", "menuactive", "open", "sizetopopup", "value"],
"menubar": ["grippyhidden", "statusbar"],
"menuitem": ["acceltext", "accessible", "accesskey", "allowevents", "autocheck", "checked", "command", "crop", "description", "image", "key", "label", "name", "selected", "tabindex", "type", "validate", "value"],
"menulist": ["accesskey", "crop", "disableautoselect", "disabled", "editable", "focused", "image", "label", "open", "preference", "readonly", "sizetopopup", "src", "tabindex", "value"],
"menupopup": ["ignorekeys", "left", "onpopuphidden", "onpopuphiding", "onpopupshowing", "onpopupshown", "position", "top"],
"menuseparator": [],

// Observes commented out to avoid triggering bug 344215.
// "observes": ["attribute", "element"],

"overlay": ["class", "id"],
"page": [], // has tons of attributes; skipping them.
"popup": ["ignorekeys", "left", "onpopuphidden", "onpopuphiding", "onpopupshowing", "onpopupshown", "position", "top"],
"popupset": [],

// Preferences commented out to avoid triggering bug 344334.
/*
"preference": ["disabled", "instantApply", "inverted", "name", "onchange", "readonly", "tabindex", "type"],
"preferences": [],
*/

"prefpane": ["helpURI", "image", "label", "onpaneload", "selected", "src"],
"prefwindow": [], // has tons of attributes; skipping them.
"progressmeter": ["mode", "value"],
"radio": ["accesskey", "command", "crop", "disabled", "focused", "image", "label", "selected", "tabindex", "value"],
// "radiogroup": ["disabled", "focused", "preference", "tabindex", "value"], // bug 360761
"resizer": ["dir"],

// Richlistbox commented out to avoid triggering bug 344228.
/*
"richlistbox": ["suppressonselect"],
"richlistitem": ["disabled", "selected", "tabindex", "value"],
*/

"row": [],
"rows": [],
"rule": ["iscontainer", "isempty", "parent", "parsetype"],
"script": ["src", "type"],
"scrollbar": ["curpos", "increment", "maxpos", "pageincrement"],
"scrollbox": [],
"scrollcorner": [],
"separator": ["orient"],
"spacer": ["flex"],
"splitter": ["collapse", "resizeafter", "resizebefore", "state"],
"stack": [],
"statusbar": [],
"statusbarpanel": ["crop", "label", "src"],
"stringbundle": ["src"],
"stringbundleset": [],
"tab": ["accesskey", "afterselected", "beforeselected", "crop", "disabled", "image", "label", "linkedpanel", "selected", "validate"],
// "tabbrowser": ["autocompleteenabled", "autocompletepopup", "autoscroll", "contentcontextmenu", "contenttooltip", "handleCtrlPageUpDown", "onbookmarkgroup", "onnewtab"], // commented out for the same reason as <browser>
"tabbox": ["eventnode", "handleCtrlPageUpDown", "handleCtrlTab"],
//"tabpanel": [], // bug 321224?
//"tabpanels": ["selectedIndex"], // bug 321224?
"tabs": ["closebutton", "disableclose", "first-tab", "last-tab", "onclosetab", "onnewtab", "onselect", "setfocus", "tooltiptextnew"],
"template": ["container", "member"],
"textnode": ["value"],
"textbox": ["cols", "disabled", "maxlength", "multiline", "onchange", "oninput", "preference", "readonly", "rows", "size", "tabindex", "timeout", "type", "value", "wrap"],
"titlebar": [],

// Toolbar stuff commented out to avoid triggering bug 344434.
/*
"toolbar": ["currentset", "customindex", "customizable", "defaultset", "grippyhidden", "grippytooliptext", "toolbarname"],
"toolbarbutton": ["accesskey", "autoCheck", "checkState", "checked", "command", "crop", "dir", "disabled", "dlgType", "group", "image", "label", "open", "orient", "tabindex", "type", "validate"],
"toolbargrippy": [],
"toolbaritem": [],
"toolbarpalette": [],
"toolbarseparator": [],
"toolbarset": [],
"toolbarspaer": [],
// "toolbarspring": [], // toolbarspring also commented out to avoid triggering bug 344340
*/

"toolbox": [],

// Tooltip commented out to avoid triggering bug 344340.
/*
"tooltip": ["crop", "default", "label", "noautohide", "onpopuphidden", "onpopuphiding", "onpopupshowing", "onpopupshown", "position"], 
*/

// Trees commented out to avoid triggering bug 344228.
/*
"tree": ["disableKeyNavigation", "disabled", "enableColumnDrag", "flags", "hidecolumnpicker", "onselect", "rows", "seltype", "statedatasource", "tabindex"],
"treecell": ["label", "mode", "properties", "ref", "src", "value"],
"treechildren": ["alternatingbackground"],
"treecol": ["crop", "cycler", "dragging", "fixed", "hidden", "hideheader", "ignoreincolumnpicker", "label", "primary", "sort", "sortActive", "sortDirection", "src", "type"],
"treecols": [],
"treeitem": ["container", "empty", "label", "open", "uri"],
"treerow": ["properties"],
"treeseparator": ["properties"],
*/

"triple": ["object", "predicate", "subject"],
"vbox": [],
"window": ["height", "hidechrome", "id", "screenX", "screenY", "sizemode", "title", "width", "windowtype"],
"wizard": [], // ...
"wizardpage": ["next", "pageid"],


//http://lxr.mozilla.org/mozilla/search?string=nsXULAtoms%3A%3A
// These are XUL elements implemented in C++ that are considered "internal" and so not listed on http://www.xulplanet.com/references/elemref/
"listboxbody": [],
// "browser": [], // probably causes the same problems as iframes
"autorepeatbutton": [],
"spring": [],
"popupgroup": [],
// "nativescrollbar": [], // 321224?
"scrollbarbutton": [],
"text": []



};




// attributes is a hash, but sometimes we want to treat it as an array-like thing.  so....
attributeList = [];
for (var prop in attributes)
  attributeList.push(prop);

function totallyRandomAttr() { 
  // Emphasize basic stuff. 
  if (rnd(3)==1) 
    return rndElt(["id", "name"]);
  return rndElt(attributeList); 
}
// attributes is a hash, but sometimes we want to treat it as an array-like thing.  so....
elementList = [];
for (var prop in elements)
  elementList.push(prop);

